SystemOrganization addCategory: #'WebStore-Core'!
SystemOrganization addCategory: #'WebStore-Announcements'!
SystemOrganization addCategory: #'WebStore-Components'!
SystemOrganization addCategory: #'WebStore-Admin'!
SystemOrganization addCategory: #'WebStore-Tests-Core'!
SystemOrganization addCategory: #'WebStore-Util'!
SystemOrganization addCategory: #'WebStore-Checkout'!
SystemOrganization addCategory: #'WebStore-Tests-UI'!
SystemOrganization addCategory: #'WebStore-Commands'!
SystemOrganization addCategory: #'WebStore-Tests-Commands'!
SystemOrganization addCategory: #'WebStore-TestResources'!
SystemOrganization addCategory: #'WebStore-TestSite'!
SystemOrganization addCategory: #'WebStore-Tests-Util'!
SystemOrganization addCategory: #'WebStore-Tests-Admin'!

TestResource subclass: #WSMagmaResource
	instanceVariableNames: 'location session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-TestResources'!

!WSMagmaResource methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 17:35'!
session
	session ifNil: [session := location newSession connectAs: 'testing'].
	^session! !

!WSMagmaResource methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 00:01'!
setUp
	location := MagmaLocalLocation path: 'testing.magma'.
	location isRepository 
		ifFalse: [MagmaRepositoryController create: location path root: Dictionary new]
		ifTrue: [[self session root: (Dictionary new)] on: Warning do: ["nothing"] ].! !

WAKom subclass: #WSKom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSKom commentStamp: 'srh 2/22/2009 19:55' prior: 0!
A WSKom is a specialized subclass of WAKom that merges GET fields and POST fields on POST.
!

!WSKom methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 19:53'!
fieldsOf: aKomRequest
	^aKomRequest method = 'POST'
		ifTrue: [ Dictionary new 
			addAll: aKomRequest getFields;
			addAll: aKomRequest postFields;
			yourself]
		ifFalse: [ aKomRequest getFields ]! !

!WARenderCanvas methodsFor: '*webstore-components' stamp: 'srh 3/10/2009 21:58'!
wsImage
	^self brush: WSImageBrush new! !

!WARenderCanvas methodsFor: '*webstore-components' stamp: 'srh 3/10/2009 22:01'!
wsImage: anImage
	^(self brush: WSImageBrush new) 
		image:anImage;
		yourself! !

Announcement subclass: #WSAddToCart
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

!WSAddToCart class methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:16'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself! !

!WSAddToCart methodsFor: 'initialization' stamp: 'srh 3/10/2009 21:24'!
initializeWithProduct: aProduct
	product := aProduct.
	self initialize.! !

!WSAddToCart methodsFor: 'accessing' stamp: 'srh 3/10/2009 21:24'!
product
	^product! !

Announcement subclass: #WSLightbox
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSLightbox class methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:59'!
component: aComponent
	^self basicNew
		initializeWithComponent: aComponent;
		yourself! !

!WSLightbox methodsFor: 'accessing' stamp: 'srh 3/10/2009 20:37'!
component
	^component! !

!WSLightbox methodsFor: 'initialization' stamp: 'srh 3/10/2009 20:37'!
initializeWithComponent: aComponent 
	component := aComponent.
	self initialize! !

TestCase subclass: #WSAddressTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSAddressTest methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:11'!
testPopulateFrom
	| a1 a2 |
	a2 := WSAddress new.
	a1 := WSShippingAddress new.
	
	a2 address1: 'a'.
	a2 address2: 'b'.
	a2 locality: 'c'.
	a2 state: 'd'.
	a2 postcode: 'e'.
	a2 country: 'f'.
	
	a1 populateFrom: a2.
	self assert: a2 address1 equals: a1 address1.	
	self assert: a2 address2 equals: a1 address2.
	self assert: a2 locality equals: a1 locality.	
	self assert: a2 postcode equals: a1 postcode.
	self assert: a2 state equals: a1 state.
	self assert: a2 country equals: a1 country.
	self deny: a2 == a1.		! !

TestCase subclass: #WSCartTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSCartTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 21:08'!
testAdd
	|c p|
	c := WSCart new.
	p := WSProduct new.
	c add: p.
	
	self assert: c items includes: p.! !

!WSCartTest methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 14:54'!
testNewInstance
	|c|
	c := WSCart new.
	self assert: c empty.! !

!WSCartTest methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 14:55'!
testNotEmpty
	|c|
	c := WSCart new.
	c add: WSProduct new.
	self deny: c empty.! !

!WSCartTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 21:09'!
testRemove
	|c p|
	c := WSCart new.
	p := WSProduct new.
	c add: p.
	c remove: p.
	
	self deny: (c items includes: p).! !

!WSCartTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 21:13'!
testTotalInDollars
	|c p1 p2|
	c := WSCart new.
	p1 := WSProduct new.
	p2 := WSProduct new.
	p1  price: 12345.
	p2 price: 54321.
	c add: p1.
	c add: p2.
	
	self assert: 666.66 equals: c totalInDollars.! !

TestCase subclass: #WSCommandTestCase
	instanceVariableNames: 'session store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Commands'!

WSCommandTestCase subclass: #WSApplyFormCommandTest
	instanceVariableNames: 'product form nameField priceField descriptionField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Commands'!

!WSApplyFormCommandTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 21:05'!
setUp
	super setUp.
	product := store products first.
	form := WSForm new.
	nameField := WSTestingField new on: #name of: product;
				 beRequired;
				 yourself.
	priceField := WSTestingField new on: #price of: product;
				 beRequired;
				 yourself.
	descriptionField := WSTestingField new on: #description of: product;
				 yourself.
				
	form 
		add: nameField;
		add: priceField;
		add: descriptionField.! !

!WSApplyFormCommandTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 15:32'!
testUpdateDescription
	self updateForm.
	self runCommand: [WSApplyFormCommand form: form].
	session abort.
	self assert: 'testing' equals: product description! !

!WSApplyFormCommandTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:18'!
testUpdateName
	self updateForm.
	self runCommand: [WSApplyFormCommand form: form].
	session abort.
	self assert: 'newName' equals: product name! !

!WSApplyFormCommandTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:31'!
testUpdatePrice
	self updateForm.
	self runCommand: [WSApplyFormCommand form: form].
	session abort.
	self assert: 666 equals: product price! !

!WSApplyFormCommandTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 21:06'!
updateForm
	nameField value: 'newName'.
	priceField value: 666.
	descriptionField value: 'testing'! !

!WSCommandTestCase class methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 23:08'!
resources
	^Array with: WSMagmaResource! !

!WSCommandTestCase methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 00:04'!
runCommand: aBlock 
	"aBlock should return a new Command"
	WACurrentSession 
		use: (WSTestSession new
				magmaSession: session;
				yourself)
		during: [ aBlock value run ]! !

!WSCommandTestCase methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 00:10'!
setUp
	super setUp.
	session := WSMagmaResource current session.
	store := WSTestingStore store.
	session commit: 
		[ session root 
			at: self class name
			put: store ].
! !

WSCommandTestCase subclass: #WSOrderCommandsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Commands'!

!WSOrderCommandsTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:32'!
testCancelOrder
	|order|
	order := store orders first.
	self runCommand: [WSCancelOrderCommand order: order reason: 'because'].
	session abort.
	self assert: (order status is: #cancelled)
! !

!WSOrderCommandsTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:32'!
testCancelOrderReason
	| order |
	order := store orders first.
	self runCommand: [WSCancelOrderCommand order: order reason: 'because'].
	session abort.
	self assert: 'because' equals: order status reason
! !

!WSOrderCommandsTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:32'!
testPlaceOrder
	| order |
	order := WSOrder new.
	order items: WSCart new.
	order items add: store products first.
		
	self runCommand: [WSPlaceOrderCommand store: store order: order].
	session abort.
	self assert: (order status is: #unconfirmed)
! !

!WSOrderCommandsTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:32'!
testShipOrder
	| order |
	order := store orders at: 3.
	self runCommand: [WSShipOrderCommand order: order].
	session abort.
	self assert: (order status is: #shipped)! !

WSCommandTestCase subclass: #WSTestProductCommands
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Commands'!

!WSTestProductCommands methodsFor: 'tests (slow)' stamp: 'srh 1/26/2009 13:39'!
testAddImage
	| p i |
	p := store products first.
	i := WSDummyImage baseName: 'newimage'.
	self runCommand:
		[ WSAddImageCommand 
			product: p
			image: i ].
	session abort.
	self assert: (p images includes: i)! !

!WSTestProductCommands methodsFor: 'tests (slow)' stamp: 'srh 2/28/2009 21:36'!
testAddProduct
	| p |
	p := WSProduct new.
	self runCommand: [ WSAddProductCommand store: store product: p].
	session abort.
	self assert: store products includes: p.! !

!WSTestProductCommands methodsFor: 'tests (slow)' stamp: 'srh 1/26/2009 00:16'!
testDeleteImage
	| p i |
	p := store products first.
	i := p images first.
	self runCommand: 
		[ WSDeleteImageCommand 
			product: p
			image: i ].
	session abort.
	self deny: (p images includes: i)! !

!WSTestProductCommands methodsFor: 'tests (slow)' stamp: 'srh 2/28/2009 21:36'!
testDeleteProduct
	| p |
	p := store products first.
	self runCommand: [ WSDeleteProductCommand store: store product: p].
	session abort.
	self deny: (store products includes: p).! !

!WSTestProductCommands methodsFor: 'tests (slow)' stamp: 'srh 2/28/2009 21:33'!
testDisable
	| p |
	p := store products first.
	self runCommand: 
		[ WSDisableProductCommand 
			product: p].
	session abort.
	self deny: p enabled.! !

!WSTestProductCommands methodsFor: 'tests (slow)' stamp: 'srh 2/28/2009 21:31'!
testEnable
	| p |
	p := store products third.
	self runCommand: 
		[ WSEnableProductCommand 
			product: p].
	session abort.
	self assert: p enabled.! !

!WSTestProductCommands methodsFor: 'tests (slow)' stamp: 'srh 1/26/2009 13:39'!
testSetPreview
	| p i |
	p := store products first.
	i := p images second.
	self runCommand: 
		[ WSSetPreviewCommand 
			product: p
			image: i].
	session abort.
	self assert: i equals: p preview.! !

TestCase subclass: #WSImageTest
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSImageTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 15:04'!
setUp
	image := WSImage new! !

!WSImageTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 17:59'!
testNamePattern
	self assert: (image fullsize matchesRegex: '^[0-9a-f\-]+-full.jpg')! !

TestCase subclass: #WSOrderTest
	instanceVariableNames: 'p order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 21:07'!
setUp
	super setUp.
	p := WSProduct new.
	order := WSOrder new 
		items: (WSCart new add: p;yourself); 
		yourself.
! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:39'!
testCancelledOrderStatus
	order placeOrder: 123.
	order cancel: 'because'.
	self assert: (order status is: #cancelled)! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:38'!
testCantShipCancelledOrder
	order placeOrder: 123.
	order cancel: 'vecause'.
	self should: [order ship] raise: Error description: 'shouldn''t be able to ship a cancelled order'.
! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 1/27/2009 21:15'!
testCantShipNewOrder
	self should: [order ship] raise: Error description: 'shouldn''t be able to ship a new order'.
! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:43'!
testConfirmPayment
	order placeOrder: 123.
	order confirmPayment: 'abc'.
	self assert: (order status is: #confirmed).! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:28'!
testInitialOrderHistory
	self assert: 1 equals: (order history size) ! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:28'!
testInitialOrderHistoryContents
	self assert: order status equals: (order history last) ! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:13'!
testNewOrderDate
	self should: [order date] raise: Error whoseDescriptionIncludes: 'been placed yet' description: 'new order shouldn''t have date'! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:06'!
testNewReference
	self assert: order reference isNil! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:24'!
testNewStatus
	self assert: (order status is: #new)! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:06'!
testOrderDate
	| time |
	time := DateAndTime now.
	order placeOrder: 123.
	self assert: (order date between: time and: time + 2 seconds)! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:28'!
testOrderHistory
	order placeOrder: 123.
	order confirmPayment: 'xyz'.
	order ship.
	self assert: 4 equals: (order history size) ! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:29'!
testOrderHistoryContents
	order placeOrder: 123.
	order confirmPayment: 'xyz'.
	order ship.
	self assert: ((order history at: 3) is:  #confirmed)! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:07'!
testOrderReference
	order placeOrder: 123.
	self assert: 123 equals: order reference.! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:24'!
testOrderStatus
	order placeOrder: 123.
	self assert: (order status is: #unconfirmed).! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:44'!
testPaymentReference
	order placeOrder: 123.
	order confirmPayment: 'abc'.
	self assert: 'abc' equals: order status reference! !

!WSOrderTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:46'!
testShippedStatus
	order placeOrder: 123.
	order confirmPayment: 'abc'.
	order ship.
	self assert: (order status is: #shipped)! !

TestCase subclass: #WSPersistenceTest
	instanceVariableNames: 'magmaSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSPersistenceTest class methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 16:24'!
resources
	^Array with: WSMagmaResource! !

!WSPersistenceTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 17:31'!
setUp
	magmaSession := WSMagmaResource current session.! !

!WSPersistenceTest methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 16:35'!
testAbort
	| s p |
	p := WSProduct new.
	s := WSStore new.
	magmaSession commit: [
		magmaSession root at: self class name put: s].
	
	magmaSession begin.
	s addProduct: p.
	magmaSession abort.
	self deny: (s products includes: p).! !

!WSPersistenceTest methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 16:37'!
testCommit
	| s p |
	p := WSProduct new.
	s := WSStore new.
	magmaSession commit: [
		magmaSession root at: self class name put: s].
	
	magmaSession begin.
	s addProduct: p.
	magmaSession commit.
	self assert: (s products includes: p).! !

!WSPersistenceTest methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 16:31'!
testPersist
	| s |
	s := WSStore new.
	magmaSession commit: [
		magmaSession root at: self class name put: s].
	
	self assert: s equals: (magmaSession root at: self class name)! !

TestCase subclass: #WSProductTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:04'!
testAddFirstImageSetsPreview
	|p i|
	
	p := WSProduct new.
	i := WSImage new.
	p addImage: i.
	self assert: i equals: p preview! !

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:03'!
testAddImage
	|p i|
	
	p := WSProduct new.
	i := WSImage new.
	p addImage: i.
	self assert: p images includes: i.! !

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 20:53'!
testNewProduct
	|p|
	p := WSProduct new.
	self assert: p images isEmpty.! !

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:25'!
testPreviewMustBeInImages
	| p i1 i2 |
	p := WSProduct new.
	i1 := WSImage new.
	i2 := WSImage new.
	
	p addImage: i1.
	self should: [p preview: i2] raise: Exception whoseDescriptionIncludes: 'must be one of the product''s images'  description: 'Didn''t raise expected Exception'! !

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 14:03'!
testPriceInDollars
	self assert: 30.45 equals: (WSProduct new price: 3045;priceInDollars)! !

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:05'!
testRemoveImage
	|p i|
	
	p := WSProduct new.
	i := WSImage new.
	p addImage: i.
	p removeImage: i.
	
	self assert: (p images includes: i) not.! !

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:18'!
testRemoveImageResetsPreview
	|p i1 i2|
	
	p := WSProduct new.
	i1 := WSImage new.
	i2 := WSImage new.
	p addImage: i1.
	p addImage: i2.
	p preview: i2.
	p removeImage: i2.
	
	self assert: i1 equals: p preview! !

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:07'!
testRemoveLastImageUnsetsPreview
	|p i|
	
	p := WSProduct new.
	i := WSImage new.
	p addImage: i.
	p removeImage: i.
	
	self assert: p preview isNil..! !

!WSProductTest methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:18'!
testSetPreview
	|p i1 i2|
	p := WSProduct new.
	i1 := WSImage new.
	i2 := WSImage new.
	p addImage: i1.
	p addImage: i2.
	p preview: i2.
	
	self assert: i2 equals: p preview! !

TestCase subclass: #WSStatusTest
	instanceVariableNames: 'status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:50'!
setUp
	status := WSStatus newFor: self! !

!WSStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:40'!
status: aState 
	status := aState! !

!WSStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:55'!
testChangeState
	status placeOrder.
	self assert: status class equals: WSUnconfirmedStatus! !

!WSStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:53'!
testDate
	| time |
	time := DateAndTime now.
	self assert: (status date 
			between: time - 1 seconds
			and: time + 1 seconds)! !

!WSStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:52'!
testIs
	self assert: (status is: #new)! !

!WSStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:52'!
testIsNot
	self deny: (status is: #foo)! !

!WSStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:51'!
testName
	self assert: #new equals: status name! !

!WSStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:51'!
testNew
	self assert: WSNewStatus equals: status class! !

TestCase subclass: #WSStatusesTest
	instanceVariableNames: 'actionMap status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

WSStatusesTest subclass: #WSCancelledStatusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSCancelledStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:04'!
setUp
	super setUp.
	status := WSCancelledStatus owner: self reason: 'because'.! !

!WSCancelledStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:57'!
testReason
	self assert: 'because' equals: status reason.! !

WSStatusesTest subclass: #WSConfirmedStatusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSConfirmedStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:56'!
setUp
	super setUp.
	status := WSConfirmedStatus owner: self reference: '1234'.
	actionMap at: #ship put: #shipped.
	actionMap at: #cancel: put: #cancelled! !

!WSConfirmedStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:06'!
testCancelReason
	status cancel: 'because'.
	self assert: 'because' equals: status reason.! !

!WSConfirmedStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:35'!
testReference
	self assert: '1234' equals: status reference.! !

WSStatusesTest subclass: #WSNewStatusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSNewStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:19'!
setUp
	super setUp.
	status := WSNewStatus owner: self.
	actionMap at: #placeOrder put: #unconfirmed! !

WSStatusesTest subclass: #WSShippedStatusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSShippedStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:02'!
setUp
	super setUp.
	status := WSShippedStatus owner: self.! !

!WSStatusesTest class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:14'!
isAbstract
	^self = WSStatusesTest! !

!WSStatusesTest class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:10'!
shouldInheritSelectors
	^true! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:30'!
assert: aBlock resultsIn: aStatusName 
	aBlock value.
	self assert: (status is: aStatusName)! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:29'!
assertAction: aSymbol
	self assertAction: aSymbol withArguments: #().! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:28'!
assertAction: aSymbol withArguments: args
	| block |
	block := [ status perform: aSymbol withArguments: args].
	(actionMap includesKey: aSymbol) 
		ifTrue: [self assert: block resultsIn: (actionMap at: aSymbol)]
		ifFalse: [self assertInvalidStateChange: block]
! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:30'!
assertInvalidStateChange: aBlock 
	self 
		should: [ aBlock value ]
		raise: Error
		whoseDescriptionIncludes: 'does not make sense'
		description: 'Action should have failed'! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:01'!
setUp
	actionMap := Dictionary new.! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:40'!
status: aStatus 
	status := aStatus! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:08'!
testCancel
	self assertAction: #cancel: withArguments: #('because')! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:37'!
testConfirmPayment
	self assertAction: #confirmPayment: withArguments: (Array with: '1234')! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:15'!
testPlaceOrder
	self assertAction: #placeOrder! !

!WSStatusesTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:02'!
testShip
	self assertAction: #ship! !

WSStatusesTest subclass: #WSUnconfirmedStatusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSUnconfirmedStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 13:56'!
setUp
	super setUp.
	status := WSUnconfirmedStatus  owner: self.
	actionMap at: #confirmPayment: put: #confirmed.
	actionMap at: #cancel: put: #cancelled.! !

!WSUnconfirmedStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:05'!
testCancelReason
	status cancel: 'because'.
	self assert: 'because' equals: status reason.! !

!WSUnconfirmedStatusTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:06'!
testConfirmedReference
	status confirmPayment: '1234'.
	self assert: '1234' equals: status reference.! !

TestCase subclass: #WSStoreTest
	instanceVariableNames: 'store p order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Core'!

!WSStoreTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 21:13'!
setUp
	super setUp.
	store := WSStore new.
	p := WSProduct new.
	order := WSOrder new 
		items: (WSCart new add: p;yourself); 
		yourself.! !

!WSStoreTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:16'!
testAddProduct
	store addProduct: p.
	self assert: (store products includes: p).
	! !

!WSStoreTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:16'!
testDeleteProduct
	store addProduct: p.
	store deleteProduct: p.
	self assert: (store products includes: p) not	! !

!WSStoreTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:06'!
testOrderReference
	store placeOrder: order.
	self assert: order reference notNil.! !

!WSStoreTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:02'!
testPlaceOrder
	store placeOrder: order.
	self assert: store orders includes: order.! !

WAFileLibrary subclass: #TestSiteFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-TestSite'!

!TestSiteFiles methodsFor: 'uploaded' stamp: 'srh 1/1/2009 22:15'!
webstoreCss
	^ '
#banner {
	position: absolute;
	top: 0;
	height: 2em;
	left: 0;
	right: 0;
	margin:0;
	font-size: 2em;
	border-bottom: solid 1px grey;
}
#nav {
	position: absolute;
	left: 0;
	top: 4em;
	width: 8em;
}

#content {
	position: absolute;
	top: 4em;
	left: 8em;
	margin-top: 0;
	border-left: solid 1px grey;
	padding-left: 1em;
	padding-top: 5px;
}

.product-preview {
	float: left;
	border: dashed 1px grey;
	margin: 3px;
	height: 8.5em;
	width: 12em;
	padding: 3px;
}

.product-preview img {
	float: left;
	margin-right: 0.5em;
	margin-bottom: 0.5em;
}
.product-preview h3 {
	margin-top: 0;
	margin-bottom: 0;
	font-size: 1em;
	clear: both;
}
.product-preview p {
	margin-top: 0;
	margin-bottom: 0;
}

.product-preview a {
	text-decoration: none;
}

.product-preview img {
	border: none;
}

.product-details {
	margin-bottom: 2em;
}

.product-details h2 {
	margin-top: 0;
}

.product-details .image-viewer {
	float: left;
	margin-right: 1em;
	margin-bottom: 0.5em;
}

.image-viewer {
	border: solid grey 1px;
	padding: 0;
	text-align: center;
}

.image-viewer img {
	border:none;
	padding: none;
}

.image-viewer ul {
	margin: 0;
	padding: 0;
	list-style: none;
	border-top: solid grey 1px;
	background-color: #eeeeee;
}

.image-viewer li {
	display: inline;
	margin: 0;
	padding: 0;
}

#lightbox {
	background-color: white;
	border: solid #404040 1px;
}

#lightbox h1 {
	background-color: #eeeeee;
	margin-top: 0;
	padding: 2x;
	text-align: center;
	font-size: 1.2em;
}

#lightbox .nav-buttons {
	background-color: #eeeeee;
	padding: 0.2em;
	text-align: right;
}

ul.wizard-tabs {
	list-style: none;
	margin: 0;
	padding: 0;
}

.wizard-tabs li {
	display: inline;
	margin-left: 0.5em;
	margin-right: 0.5em;
}

.wizard-tabs li.disabled {
	color: grey;
}

.cart-view {
	margin: 0.5em;
}

#confirm-order {
	padding-left: 0.5em;
	padding-right: 0.5em;
}

#confirm-order h2 {
	margin-top: 0;
	margin-bottom: 0;
	font-size: 1.2em;
}

#confirm-order div {
	margin: 0;
}
#confirm-order p {
	margin-top: 0;
}

#confirm-order dl {
	margin-top: 0.5em;
	padding: 0;
}

#confirm-order dt {
	font-weight: bold;
}

#confirm-order dd {
	margin-left: 8em;
	margin-top: -1em;
}

label {
	width: 10em;
	display: inline-block;
	text-align: right;
	margin-right: 0.5em;
}
'! !

WAFileLibrary subclass: #WSImageLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSImageLibrary commentStamp: '<historical>' prior: 0!
This class adds the ability to serve content from files external to the image.

The files go in to a subdirectory from the running directory called 'files'
The URL to access the files is: http://localhost:7777/seaside/files/external/myfile.png

Seaside protects against malicious users attempting to use '..' to access above the 'files' directory.!

!WSImageLibrary class methodsFor: 'testing' stamp: 'srh 12/31/2008 08:05'!
handlesFolder: aSymbol 
	^ aSymbol = #external! !

!WSImageLibrary class methodsFor: 'testing' stamp: 'srh 12/31/2008 08:40'!
path
	^'files/external/'! !

!WSImageLibrary methodsFor: 'accessing' stamp: 'srh 12/31/2008 08:31'!
documentAt: aFilename ifAbsent: aBlock 
	| fn files mimeType fileStream |
	files := FileDirectory default directoryNamed: 'files'.
	files exists
		ifFalse: [^ aBlock value].
	fn := files fullNameFor: aFilename.
	^ (files fileOrDirectoryExists: fn)
		ifTrue: [mimeType := self mimetypeForFile: aFilename.
			fileStream := (files readOnlyFileNamed: fn) binary.
			(WAStreamResponse on: fileStream)
				contentType: (mimeType
						ifNil: ['application/octet-stream']);
				 headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
				 yourself]
		ifFalse: [aBlock value]! !

!WSImageLibrary methodsFor: 'accessing' stamp: 'srh 12/31/2008 08:06'!
urlOf: aSymbol using: aHandler 
	^ aHandler baseUrl addToPath: 'external';
		
		addToPath: (self asFilename: aSymbol);
		 yourself! !

SCComponentTestCase subclass: #WSFieldTest
	instanceVariableNames: 'field value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Util'!

WSFieldTest subclass: #WSFieldGroupTest
	instanceVariableNames: 'fields list labels labelBlock legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Util'!

!WSFieldGroupTest methodsFor: 'actions' stamp: 'srh 3/9/2009 12:55'!
addItem: anItem
	(self lastResponse entitiesNamed: 'fieldset') first inputs first value: anItem.
	self submitForm: self lastResponse forms first 
		pressingButton: (self lastResponse buttonWithValue: 'Add' )! !

!WSFieldGroupTest methodsFor: 'accessing' stamp: 'srh 3/11/2009 22:19'!
fieldClass
	^WSFieldGroup! !

!WSFieldGroupTest methodsFor: 'accessing' stamp: 'srh 3/8/2009 09:23'!
fieldset
	^(self lastResponse entitiesNamed: 'fieldset') first! !

!WSFieldGroupTest methodsFor: 'accessing' stamp: 'srh 3/8/2009 11:03'!
itemAt: position
	^(self rowAt: position) entities first! !

!WSFieldGroupTest methodsFor: 'accessing' stamp: 'srh 3/8/2009 10:53'!
itemCount
	^(self lastResponse entitiesNamed: 'tr') size! !

!WSFieldGroupTest methodsFor: 'accessing' stamp: 'srh 3/8/2009 09:56'!
options
	^ (self fieldset entitiesNamed: 'input') first options! !

!WSFieldGroupTest methodsFor: 'actions' stamp: 'srh 3/8/2009 11:02'!
removeItemAt: position 
	self submitForm: self lastResponse forms first
		pressingButton: (((self rowAt: position) entitiesNamed: 'td') at: 2) inputs first.! !

!WSFieldGroupTest methodsFor: 'accessing' stamp: 'srh 3/8/2009 11:00'!
rowAt: position 
	^ (self lastResponse entitiesNamed: 'tr') at: position! !

!WSFieldGroupTest methodsFor: 'running' stamp: 'srh 3/11/2009 22:21'!
setUp
	value := #().
	super setUp.
	fields := OrderedCollection new.
	list := #(#foo #bar #baz ).
	legend := 'Test Group'.
	labels := #('Foo' 'Bar' 'Baz' ).
	field
		list: list;
		label: legend;
		labels: [ :item | item asCapitalizedPhrase ].
! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/8/2009 10:58'!
testAdd
	self initialRequest.
	self addItem: 'Foo'.
	self assert: 1 equals: self itemCount! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/8/2009 11:14'!
testAddCorrectItem
	self initialRequest.
	self addItem: 'Bar'.
	self assert: 'bar' equals: (self itemAt: 1) contentString.! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/11/2009 22:13'!
testAddDoesntModifyOriginalBeforeSave
	self initialRequest.
	self addItem: 'Foo'.
	self deny: (value includes: #foo)! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/11/2009 22:07'!
testFactory
	| num |
	num := 0.
	field newItem: 
		[ :item | 
		num := num + 1.
		item displayString , num printString ].
	self initialRequest.
	self addItem: 'Foo'.
	self addItem: 'Bar'.
	self addItem: 'Baz'.
	self 
		assert: 'bar2'
		equals: (self itemAt: 2) contentString! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/8/2009 10:12'!
testLabels
	self initialRequest.
	self assert: ((self options collect: [ :o | o contentString ]) hasEqualElements: labels)! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/8/2009 10:12'!
testLegend
	self initialRequest.
	self 
		assert: legend
		equals: (self fieldset entitiesNamed: 'legend') first contentString! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/11/2009 22:07'!
testList
	field labels: nil.
	self initialRequest.
	self assert: ((self options collect: [ :o | o contentString ]) hasEqualElements: list)! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/8/2009 10:47'!
testNoItems
	self initialRequest.
	self assert: 0 equals: self itemCount.! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/8/2009 10:58'!
testRemove
	self initialRequest.
	self addItem: 'Foo'.
	self addItem: 'Bar'.
	self removeItemAt: 1.
	self assert: 1 equals: self itemCount! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/11/2009 22:07'!
testRemoveCorrectItem
	| num |
	num := 0.
	field newItem: 
		[ :item | 
		num := num + 1.
		item displayString , num printString ].
	self initialRequest.
	self addItem: 'Foo'.
	self addItem: 'Bar'.
	self addItem: 'Baz'.
	self removeItemAt: 3.
	self 
		assert: 'bar2'
		equals: (self itemAt: 2) contentString! !

!WSFieldGroupTest methodsFor: 'tests' stamp: 'srh 3/11/2009 22:13'!
testSave
	self initialRequest.
	self addItem: 'Foo'.
	self save.
	self 
		assert: value
		includes: #foo! !

!WSFieldTest class methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 22:08'!
shouldInheritSelectors
	^true! !

!WSFieldTest methodsFor: 'accessing' stamp: 'srh 3/11/2009 22:17'!
fieldClass
	^WSField! !

!WSFieldTest methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 22:09'!
initialRequest
	self 
		newApplicationWithRootClass: WSFieldHolder
		createWith: 
			[ WSFieldHolder new
				add: field;
				yourself ].
	self establishSession! !

!WSFieldTest methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 22:10'!
save
	self submitForm: self lastResponse forms first 
		pressingButton: (self lastResponse buttonWithValue: 'Save' )! !

!WSFieldTest methodsFor: 'accessing' stamp: 'srh 3/11/2009 22:25'!
setUp
	super setUp.
	field := self fieldClass new 
		label: self fieldClass name;
		on: #value of: self; 
		yourself! !

!WSFieldTest methodsFor: 'accessing' stamp: 'srh 3/11/2009 22:16'!
value
	^ value! !

!WSFieldTest methodsFor: 'accessing' stamp: 'srh 3/11/2009 22:16'!
value: anObject
	value := anObject! !

WSFieldTest subclass: #WSNumericFieldTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Util'!

!WSNumericFieldTest methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 22:19'!
fieldClass
	^WSNumericField! !

!WSNumericFieldTest methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 22:29'!
input
	^self lastResponse forms first inputs first! !

!WSNumericFieldTest methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 22:26'!
setUp
	super setUp.! !

!WSNumericFieldTest methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 22:24'!
testInitialValue
	self initialRequest.
	self assert: '' equals: self input contentString! !

SCComponentTestCase subclass: #WSStoreAdminTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Admin'!

!WSStoreAdminTest methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 21:53'!
configureApplicationForComponent: aComponentClass
	super configureApplicationForComponent: aComponentClass.
	app preferenceAt: #sessionClass put: WSTestSession.! !

!WSStoreAdminTest methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 11:47'!
setUp
	self newApplicationWithRootClass: WSStoreAdmin.
	self establishSession.
! !

!WSStoreAdminTest methodsFor: 'as yet unclassified' stamp: 'srh 1/27/2009 20:30'!
testManageOrders
	self followAnchor: (self lastResponse anchorWithLabel: 'Manage Orders').
	self assert: (self lastResponse entitiesNamed: 'label') first contentString 
				= 'Show: '! !

!WSStoreAdminTest methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 11:50'!
testManageProducts
	self followAnchor: (self lastResponse anchorWithLabel: 'Manage Products').
	self assert: (self lastResponse entitiesNamed: 'a') first contentString 
				= 'Add Product'! !

SCComponentTestCase subclass: #WSWebTest
	instanceVariableNames: 'store sessionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

WSWebTest subclass: #WSCartViewTest
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

WSCartViewTest subclass: #WSCartViewDialogTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSCartViewDialogTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:50'!
initialRequestWith: aCart
	self newApplicationWithRootClass: WSCartViewDialog
		createWith: [ WSCartViewDialog cart: aCart ].
	self establishSession! !

!WSCartViewDialogTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:14'!
testBack
	self initialRequest.
	self followAnchor: (self lastResponse anchorWithLabel: 'Back').
	self assert: self componentAnswered.! !

!WSCartViewDialogTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:35'!
testCheckout
	self initialRequest.
	self followAnchor: (self lastResponse anchorWithLabel: 'Checkout').
	self assert: 'wizard-tabs' equals: self lastResponse bodyElement entities first cssClass ! !

!WSCartViewDialogTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:05'!
testTitle
	self initialRequest.
	self assert: 'Current Order' equals: (self lastResponse entitiesNamed: 'h1') first contentString.! !

WSCartViewTest subclass: #WSCartViewPageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSCartViewPageTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 14:45'!
initialRequestWith: aCart
	self newApplicationWithRootClass: WSCartViewPage 
		initializeWith: [ :c | c model: (WSOrder new items: aCart; yourself) ].
	self establishSession! !

!WSCartViewPageTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:37'!
testEnabled
	self initialRequest.
	self assert: self component enabled! !

!WSCartViewPageTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:37'!
testValid
	self initialRequest.
	self assert: self component valid! !

!WSCartViewTest class methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 14:47'!
shouldInheritSelectors
	^true! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:01'!
initialRequest
	self initialRequestWith: cart! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:50'!
initialRequestWith: aCart
	self newApplicationWithRootClass: WSCartView
		createWith: [ WSCartView cart: aCart ].
	self establishSession! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 14:06'!
itemCount
	^((self lastResponse entityWithId: 'cart-items') entitiesNamed: 'tr') size.! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 14:10'!
itemRow: itemNo
	^(((self lastResponse entityWithId: 'cart-items') entitiesNamed: 'tr') at: itemNo) entitiesNamed: 'td'! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 12:53'!
nameOf: itemNo
	^((self itemRow: itemNo) at: 2) contentString.! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 14:16'!
previewFor: itemNo
	^((self itemRow: itemNo) first) entities first! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 14:15'!
priceOf: itemNo
	^((self itemRow: itemNo) at: 3) contentString.! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 14:53'!
removeAnchorFor: itemNo
	^((self itemRow: itemNo) at: 4) anchors first.! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:55'!
setUp
	super setUp.
	cart := WSCart new.
	cart add: store products first.
	cart add: store products second.
! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:01'!
testItems
	self initialRequest.
	self 
		assert: 2
		equals: self itemCount! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:40'!
testNames
	self initialRequest.
	self 
		assert: (store products first) name
		equals: (self nameOf: 1).
	self 
		assert: (store products second) name
		equals: (self nameOf: 2)
		! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:41'!
testPreviews
	self initialRequest.
	self 
		assert: WSImageLibrary path, store products first preview thumbnail
		equals: ((self previewFor: 1) attributeAt: 'src').
	self 
		assert: WSImageLibrary path, store products second preview thumbnail
		equals: ((self previewFor: 2) attributeAt: 'src').
! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:41'!
testPrices
	self initialRequest.
	self 
		assert: '$', store products first priceInDollars printString
		equals: (self priceOf: 1).
	self 
		assert: '$', store products second priceInDollars printString
		equals: (self priceOf: 2)
		! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:04'!
testRemoveItem
	self initialRequest.
	self followAnchor: (self removeAnchorFor: 1).
	self assert: 1 equals: self itemCount! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:41'!
testRemoveItemUpdatesTotal
	self initialRequest.
	self followAnchor: (self removeAnchorFor: 1).
	self assert: '$', store products second priceInDollars printString equals: self total! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 19:04'!
testTotal
	self initialRequest.
	self 
		assert: '$' , cart totalInDollars printString
		equals: self total! !

!WSCartViewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 14:05'!
total
	^(self lastResponse entityWithId: 'cart-total') contentString! !

WSWebTest subclass: #WSCartWidgetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSCartWidgetTest methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:55'!
initialRequestWith: aCart
	self newApplicationWithRootClass: WSComponentHolder
		initializeWith: [ :holder |  holder add: (WSCartWidget new)].
	sessionBlock := [ :s | s cart: aCart].
	self establishSession! !

!WSCartWidgetTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:42'!
testDetails
	self initialRequestWith: (WSCart new add: store products first; yourself).
	self assert: 'Items: 1 Total: $', store products first priceInDollars printString equals: (self lastResponse entitiesNamed: 'p') first contentString! !

!WSCartWidgetTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 18:17'!
testEmpty
	self initialRequestWith: WSCart new.
	self assert: 0 equals: (self lastResponse entitiesWithClass: 'cart-widget') first entities size.! !

!WSCartWidgetTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:42'!
testNotEmpty
	self initialRequestWith: (WSCart new add: store products first; yourself).
	self assert: 'Your Order' equals: (self lastResponse entitiesNamed: 'h3') first contentString.! !

!WSCartWidgetTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:42'!
testReview
	self initialRequestWith: (WSCart new add: store products first; yourself).
	self followAnchor: (self lastResponse anchorWithLabel: 'Review').
	
	self assert: 'Current Order' equals: (self lastResponse entitiesNamed: 'h1') first contentString.! !

WSWebTest subclass: #WSCheckoutProcessTest
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSCheckoutProcessTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:40'!
initialize
	super initialize.
	sessionBlock := [ :s | s store: store]! !

!WSCheckoutProcessTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:22'!
placeOrder: anOrder
	self newApplicationWithRootClass: WSCheckoutProcess
		initializeWith: [ :c | c wizard:(WSTestOrderWizard new order: anOrder;yourself) ].
	self establishSession! !

!WSCheckoutProcessTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:52'!
setUp
	super setUp.
	order := WSOrder new
		customer: (WSCustomer new
			name: 'Stuart Herring';
			phone: '123459567';
			email: 'testing@example.com');
		address: (WSShippingAddress new
				name: 'Stuart Herring';
				address1: 'Over here';
				locality: 'Testville';
				postcode: '1234';
				state: 'ACT';
				country: 'Australia').! !

!WSCheckoutProcessTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:27'!
testPlaceOrder
	order items: (WSCart new add: store products first;yourself).
	self placeOrder: order.
	self assert: '/us/cgi-bin/webscr' equals: (self browser history last key url)! !

WSWebTest subclass: #WSImageManagerTest
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Admin'!

!WSImageManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:07'!
initialRequest
	self newApplicationWithRootClass: WSImageManager
		createWith: [ WSImageManager for: p ].
	self establishSession! !

!WSImageManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 14:04'!
setUp
	super setUp.
	p := store products first.! !

!WSImageManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 14:34'!
testAdd
	self initialRequest.
	self followAnchor: (self lastResponse anchorWithLabel: 'Add Image').
	self assert: SCFileHtmlInput  equals: (self lastResponse entitiesNamed: 'input') first class! !

!WSImageManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 14:19'!
testDelete
	| i|
	i := p images first.
	self initialRequest.
	self followAnchor: (self lastResponse anchorsWithLabel: 'Delete') first.
	self deny: (p images includes: i)! !

!WSImageManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 14:08'!
testDone
	self initialRequest.
	self followAnchor: (self lastResponse anchorWithLabel: 'Done').
	self assert: self componentAnswered.! !

!WSImageManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 14:33'!
testEdit
	self initialRequest.
	self followAnchor: (self lastResponse anchorsWithLabel: 'Edit') first.
	self assert: SCFileHtmlInput  equals: (self lastResponse entitiesNamed: 'input') first class! !

!WSImageManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 14:17'!
testSetAsPreview
	self initialRequest.
	self followAnchor: (self lastResponse anchorsWithLabel: 'Set as Preview') second.
	self assert: p images second equals: p preview! !

WSWebTest subclass: #WSOrderManagerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Admin'!

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:29'!
formatDate: aDate
	^aDate asDate printFormat: #(3 2 1 - 1 1 2).! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:10'!
initialRequest
	self newApplicationWithRootClass: WSOrderManager
		createWith: [ WSOrderManager store: store ].
	self establishSession! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 13:49'!
rows
	| table |
	table := (self lastResponse entitiesNamed: 'table') first.
	^(table entitiesNamed: 'tr') allButFirst collect: [ :tr | tr entitiesNamed: 'td' ]! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 13:49'!
setUp
	super setUp.! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:42'!
testCancel
	self initialRequest.
	self followAnchor: (self  lastResponse anchorWithLabel: 'Cancel').
	self answerRequestWith: 'because'.
	self assert: ((self rows first at: 6) contentString beginsWith: 'Cancelled')! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 13:49'!
testDone
	self initialRequest.
	self followAnchor: (self lastResponse anchorWithLabel: 'Done').
	self assert: self componentAnswered.! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:20'!
testFilter
	| form | 
	self initialRequest.
	form := 	self lastResponse forms first.
	(form entitiesNamed: #input) first selectOptionWithText: 'Cancelled'.
	self submitForm: form.
	self assert: 1 equals: self rows size! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 22:10'!
testFilterSelectsCorrectRecords
	| form | 
	self initialRequest.
	form := 	self lastResponse forms first.
	(form entitiesNamed: #input) first selectOptionWithText: 'Cancelled'.
	self submitForm: form.
	self assert: ((self rows first at: 6) contentString beginsWith: 'Cancelled')! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 14:04'!
testListSize
	self initialRequest.
	self assert: store orders size  equals: self rows size.! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:12'!
testShip
	self initialRequest.
	self followAnchor: (self  lastResponse anchorWithLabel: 'Ship').
	self confirmYes.
	self assert: (((self rows at: 3) at: 6) contentString beginsWith: 'Shipped')! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:09'!
testShowCancelledDate
	| o |
	o := store orders second.
	self initialRequest.
	self 
		assert: 'Cancelled (', (self formatDate: o status date), ')' 
		equals: ((self rows second) at: 6) contentString.! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:24'!
testShowItems
	self initialRequest.
	self assert: store orders first items count printString equals: ((self rows first) at: 3) contentString.! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:19'!
testShowName
	self initialRequest.
	self assert: store orders first customer name equals: (self rows first) second contentString.! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 13:51'!
testShowReference
	self initialRequest.
	self assert: store orders first reference equals: (self rows first) first contentString.! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:12'!
testShowShippedDate
	| o |
	o := store orders third.
	self initialRequest.
	self 
		assert: 'Shipped (', (self formatDate: o status date), ')' 
		equals: ((self rows last) at: 6) contentString.! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:43'!
testShowStatus
	self initialRequest.
	self assert:  (((self rows first) at: 6) contentString beginsWith: (store orders first status name asCapitalizedPhrase))! !

!WSOrderManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 14:12'!
testShowTotal
	self initialRequest.
	self assert: '$', store orders first items totalInDollars printString equals: ((self rows first) at: 4) contentString.! !

WSWebTest subclass: #WSPaypalCheckoutTest
	instanceVariableNames: 'order paypalEmail paypalHost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:32'!
configureApplicationForComponent: aComponentClass 
	super configureApplicationForComponent: aComponentClass.
	app configuration addAncestor: WSConfiguration new.
	app 
		preferenceAt: #paypalHost
		put: paypalHost.
	app 
		preferenceAt: #accountEmail
		put: paypalEmail! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:38'!
fieldNamed: aName 
	^ self browser history last key getFields at: aName! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:52'!
initialRequest
	self newApplicationWithRootClass: WSPayPalCheckout   createWith: [ WSPayPalCheckout  order: order ].
	self establishSession! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:38'!
setUp
	super setUp.
	paypalEmail := 'test@example.com'.
	paypalHost := 'localhost'.
	order := WSOrder new
		customer: (WSCustomer new
			name: 'Stuart Herring';
			phone: '123459567';
			email: 'testing@example.com');
		address: (WSShippingAddress new
				name: 'Stuart Herring';
				address1: 'Over here';
				address2: 'Over there';
				locality: 'Testville';
				postcode: '1234';
				state: 'ACT';
				country: 'Australia').
	order items: (WSCart new add: store products first; add: store products second;yourself).
! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testAddress1
	self initialRequest.
	self 
		assert: order address address1
		equals: (self fieldNamed: 'address1') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testAddress2
	self initialRequest.
	self 
		assert: order address address2
		equals: (self fieldNamed: 'address2') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testCity
	self initialRequest.
	self 
		assert: order address locality
		equals: (self fieldNamed: 'city') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testCmd
	self initialRequest.
	self 
		assert: '_cart'
		equals: (self fieldNamed: 'cmd') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testCountry
	self initialRequest.
	self 
		assert: order address country
		equals: (self fieldNamed: 'country') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testCurrency
	self initialRequest.
	self 
		assert: 'AUD'
		equals: (self fieldNamed: 'currency_code') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testFirstName
	self initialRequest.
	self 
		assert: (order customer name splitOn: ' ') first
		equals: (self fieldNamed: 'first_name') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testItemAmount
	self initialRequest.
	self 
		assert: order items items first priceInDollars printString
		equals: (self fieldNamed: 'amount_1') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:42'!
testItemCount
	self initialRequest.
	self assert: order items count equals: (self browser history last key getFields keys
			select: [:f| f  startsWith: 'item_name_']) size! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testItemName
	self initialRequest.
	self 
		assert: order items items first name
		equals: (self fieldNamed: 'item_name_1') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testLastName
	self initialRequest.
	self 
		assert: (order customer name splitOn: ' ') last
		equals: (self fieldNamed: 'last_name') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testPaypalEmail
	self initialRequest.
	self 
		assert: paypalEmail
		equals: (self fieldNamed: 'business') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 18:32'!
testRm
	self initialRequest.
	self 
		assert: '2'
		equals: (self fieldNamed: 'rm') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testState
	self initialRequest.
	self 
		assert: order address state
		equals: (self fieldNamed: 'state') value! !

!WSPaypalCheckoutTest methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:30'!
testUpload
	self initialRequest.
	self 
		assert: '1'
		equals: (self fieldNamed: 'upload') value! !

WSWebTest subclass: #WSProductEditorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Admin'!

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 23:16'!
addType: typeName
	self selectType value: typeName.
	self 
		submitForm: self lastResponse forms first 
		pressingButton: (self lastResponse buttonWithValue: 'Add' )! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:54'!
initialRequest
	self newApplicationWithRootClass: WSProductEditor
		createWith: [ WSProductEditor product: store products first ].
	self establishSession! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:08'!
save
	self 
		submitForm: self lastResponse forms first
		pressingButton: (self lastResponse buttonWithValue: 'Save')! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 23:09'!
selectType
	^ self lastResponse inputs detect: [ :i | i isSelectInput ]! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 23:14'!
testAddOption
	self initialRequest.
	self addType: 'Text'.
	self assert: 'Text' equals: ((self lastResponse entitiesNamed: 'fieldset') first entitiesNamed: 'label') first contentString.! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 23:00'!
testCancelAnswers
	self initialRequest.
	self 
		submitForm: self lastResponse  forms first 
		pressingButton: (self lastResponse buttonWithValue: 'Cancel').
	
	self assert: self componentAnswered! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:12'!
testExistingOption
	store products first options: (OrderedCollection with: (WSTextOption new name: 'Text Option'; yourself)).
	self initialRequest.
	self assert: 'Text Option' equals: ((self lastResponse entitiesNamed: 'fieldset') first inputs at: 3) value.! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:17'!
testNewOptionIsBlank
	self initialRequest.
	self addType: 'Text'.
	self assert: ((self lastResponse entitiesNamed: 'fieldset') first inputs at: 3) value isNil! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 23:06'!
testOptions
	self initialRequest.
	self 
		assert: (self selectType options collect: [ :o | o contentString ])
		includes: 'Text'! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:08'!
testSaveAnswers
	self initialRequest.
	self save.
	self assert: self componentAnswered! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 12:04'!
testSaveIncompleteDoesntAnswer
	self initialRequest.
	self addType: 'Text'.
	"Simulate a real form submit - if we don't do this, the value will be 'nil', which is considered OK 
	(so as to allow the first rendering to not be full of errors)"
	((self lastResponse entitiesNamed: 'fieldset') first inputs at: 3) value: ''.
	
	self save.
	self deny: self componentAnswered.
! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 12:14'!
testSaveWithOption
	self initialRequest.
	self addType: 'Text'.
	((self lastResponse entitiesNamed: 'fieldset') first inputs at: 3) value: 'New Value'.
	self save.
	self assert: 'New Value' equals: store products first options first name! !

!WSProductEditorTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:23'!
testSaveWithOptionAnswers
	self initialRequest.
	self addType: 'Text'.
	((self lastResponse entitiesNamed: 'fieldset') first inputs at: 3) value: 'New Value'.
	self save.
	self assert: self componentAnswered.! !

WSWebTest subclass: #WSProductManagerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Admin'!

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:09'!
initialRequest
	self newApplicationWithRootClass: WSProductManager
		createWith: [ WSProductManager store: store ].
	self establishSession! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:31'!
rows
	| table |
	table := (self lastResponse entitiesNamed: 'table') first.
	^(table entitiesNamed: 'tr') allButFirst collect: [ :tr | tr entitiesNamed: 'td' ]! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:12'!
setUp
	super setUp.! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:50'!
testAdd
	self initialRequest.
	self followAnchor: (self lastResponse anchorWithLabel: 'Add Product').
	self assert: 'Name:'  equals: (self lastResponse entitiesNamed: 'label') first contentString! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:40'!
testDelete
	| name |
	name :=  store products second name.
	self initialRequest.
	self followAnchor: (self lastResponse anchorsWithLabel: 'Delete') second.
	self assert: 'Really delete ', name, '?' equals: (self lastResponse entitiesNamed: 'h3') first contentString.! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:48'!
testDeleteCancel
	| size |
	size :=  store products size.
	self initialRequest.
	self followAnchor: (self lastResponse anchorsWithLabel: 'Delete') second.
	self confirmNo.
	self assert: size equals: self rows size! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:49'!
testDeleteConfirm
	| size |
	size :=  store products size.
	self initialRequest.
	self followAnchor: (self lastResponse anchorsWithLabel: 'Delete') second.
	self confirmYes.
	self assert: (size - 1) equals: self rows size! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:49'!
testDeleteRemovesCorrectItem
	| name |
	name :=  store products second name.
	self initialRequest.
	self followAnchor: (self lastResponse anchorsWithLabel: 'Delete') second.
	self confirmYes.
	self deny: (self rows anySatisfy: [:r | name = r second contentString ])! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:08'!
testDone
	self initialRequest.
	self followAnchor: (self lastResponse anchorWithLabel: 'Done').
	self assert: self componentAnswered.! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:50'!
testEdit
	self initialRequest.
	self followAnchor: (self lastResponse anchorsWithLabel: 'Edit') first.
	self assert: 'Name:'  equals: (self lastResponse entitiesNamed: 'label') first contentString.! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:29'!
testList
	self initialRequest.
	self assert: store products second name  equals: (self rows second) second contentString.! !

!WSProductManagerTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:29'!
testListSize
	self initialRequest.
	self assert: store products size  equals: self rows size.! !

WSWebTest subclass: #WSProductPreviewTest
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 16:21'!
initialRequest
	self 
		newApplicationWithRootClass: WSComponentHolder
		initializeWith: [ :holder | holder add: (WSProductPreview  product: product parent: holder) ].
	self establishSession! !

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:37'!
setUp
	super setUp.
	product := store products first.! !

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 12:45'!
testAddToCart
	self initialRequest.
	self session on: WSLightbox do: [ :ann | self component call: ann component  ].
	self followAnchor: (self lastResponse anchorWithLabel: 'Add to Order').
	self assert: 'Add Item' equals: ((self lastResponse entityWithId: 'lightbox') entitiesNamed: 'h1') first contentString! !

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 13:44'!
testInStock
	self initialRequest.
	self 
		assert: 'Add to Order'
		equals: (self lastResponse entitiesNamed: 'p') second anchors first contentString! !

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:44'!
testName
	self initialRequest.
	self 
		assert: product name
		equals: (self lastResponse entitiesNamed: 'h3') first anchors first contentString! !

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:44'!
testPreviewImage
	self initialRequest.
	self 
		assert: WSImageLibrary path , product preview thumbnail
		equals: ((self lastResponse bodyElement entitiesNamed: 'img') first attributeAt: 'src')! !

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:44'!
testPrice
	self initialRequest.
	self 
		assert: '$' , product priceInDollars printString
		equals: (self lastResponse entitiesNamed: 'p') first contentString! !

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:44'!
testViewDetails
	self initialRequest.
	self followAnchor: (self lastResponse anchorWithLabel: product name).
	self 
		assert: 'product-details'
		equals: (self lastResponse entitiesNamed: 'div') first cssClass! !

!WSProductPreviewTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 13:44'!
testViewDetailsFromImage
	self initialRequest.
	self followAnchor: (self lastResponse anchors detect: [ :a | a entities first tag = 'img' ]).
	self 
		assert: 'product-details'
		equals: (self lastResponse entitiesNamed: 'div') first cssClass! !

!WSWebTest methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:13'!
answerRequestWith: text
	| form |
	form := self lastResponse forms first.
	form textInputs first value: text.
	self submitForm: form pressingButton: (form buttons detect: [:b | b value = 'Ok']).
! !

!WSWebTest methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 13:37'!
configureApplicationForComponent: aComponentClass
	super configureApplicationForComponent: aComponentClass.
	app preferenceAt: #sessionClass put: WSTestSession.! !

!WSWebTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:47'!
confirmNo
	| form |
	form := self lastResponse forms first.
	self submitForm: form pressingButton: (form buttons detect: [:b | b value = 'No']).
! !

!WSWebTest methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 16:47'!
confirmYes
	| form |
	form := self lastResponse forms first.
	self submitForm: form pressingButton: (form buttons detect: [:b | b value = 'Yes']).
! !

!WSWebTest methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:39'!
sessionCreated: aSession
	sessionBlock ifNotNil: [ sessionBlock value: aSession]! !

!WSWebTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:37'!
setUp
	super setUp.
	store := WSTestingStore store.
! !

!WSWebTest methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 16:06'!
store
	^store! !

Object subclass: #WSCommand
	instanceVariableNames: 'transactionProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSCommand commentStamp: 'srh 1/25/2009 21:55' prior: 0!
A WSCommand is a base class for implemting Commands.
A command is a single unit of work within the system, and operates within a transaction.
If a command throws an exception, the transaction will be rolled back.

Instance Variables
	transactionProvider:		<Object>

transactionProvider
	- An object that implements #commit: and #abort.  The default implementation pulls it from the Seaside session, and assumes it's available as #magmaSession
!

WSCommand subclass: #WSAddProductCommand
	instanceVariableNames: 'store product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSAddProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:40'!
store: aStore product: aProduct 
	^self basicNew
		initializeWithStore: aStore product: aProduct;
		yourself.! !

!WSAddProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:41'!
do
	store addProduct: product.! !

!WSAddProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:41'!
initializeWithStore: aStore product: aProduct
	store := aStore.
	product := aProduct.
	self initialize.! !

WSCommand subclass: #WSApplyFormCommand
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSApplyFormCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:20'!
form: aForm
	^self basicNew
		initializeWithForm: aForm;
		yourself! !

!WSApplyFormCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:29'!
do
	form save.! !

!WSApplyFormCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:20'!
initializeWithForm: aForm
	form := aForm.
	self initialize.! !

WSCommand subclass: #WSCancelOrderCommand
	instanceVariableNames: 'order reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSCancelOrderCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 20:56'!
order: anOrder reason: aReason
	^self basicNew
		initializeWithOrder: anOrder reason: aReason;
		yourself! !

!WSCancelOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:38'!
do
	order cancel: reason.! !

!WSCancelOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 20:56'!
initializeWithOrder: anOrder reason: aReason.
	self initialize.
	order := anOrder.
	reason := aReason.! !

!WSCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:15'!
new
	self shouldNotImplement! !

!WSCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:05'!
do
	"Override this to actually do something"! !

!WSCommand methodsFor: 'initialization' stamp: 'srh 1/25/2009 21:59'!
initialize
	super initialize.
	transactionProvider := WACurrentSession value magmaSession.! !

!WSCommand methodsFor: 'processing' stamp: 'srh 1/26/2009 00:19'!
run
	[transactionProvider
		commit: [self do]]
		on: Error
		do: [:e | 
			transactionProvider abort.
			e signal]! !

WSCommand subclass: #WSDeleteProductCommand
	instanceVariableNames: 'store product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSDeleteProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:40'!
store: aStore product: aProduct 
	^self basicNew
		initializeWithStore: aStore product: aProduct;
		yourself.! !

!WSDeleteProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:42'!
do
	store deleteProduct: product! !

!WSDeleteProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:41'!
initializeWithStore: aStore product: aProduct
	store := aStore.
	product := aProduct.
	self initialize.! !

WSCommand subclass: #WSPlaceOrderCommand
	instanceVariableNames: 'store order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSPlaceOrderCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:22'!
store: aStore order: anOrder
	^self basicNew
		initializeWithStore: aStore order: anOrder;
		yourself! !

!WSPlaceOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:39'!
do
	store placeOrder: order! !

!WSPlaceOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:23'!
initializeWithStore: aStore order: anOrder
	store := aStore.
	order := anOrder.
	self initialize.
! !

WSCommand subclass: #WSProductCommand
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

WSProductCommand subclass: #WSAddImageCommand
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSAddImageCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:36'!
product: aProduct image: anImage
	^self basicNew
		initializeWithProduct: aProduct image: anImage;
		yourself! !

!WSAddImageCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:37'!
do
	product addImage: image! !

!WSAddImageCommand methodsFor: 'initialization' stamp: 'srh 1/26/2009 13:36'!
initializeWithProduct: aProduct image: anImage
	image := anImage.
	self initializeWithProduct: aProduct.
	! !

WSProductCommand subclass: #WSDeleteImageCommand
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSDeleteImageCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:17'!
product: aProduct image: anImage
	^self basicNew
		initializeWithProduct: aProduct image: anImage;
		yourself! !

!WSDeleteImageCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:19'!
do
	product removeImage: image! !

!WSDeleteImageCommand methodsFor: 'initialization' stamp: 'srh 1/25/2009 23:03'!
initializeWithProduct: aProduct image: anImage
	image := anImage.
	self initializeWithProduct: aProduct.
	! !

WSProductCommand subclass: #WSDisableProductCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSDisableProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:39'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSDisableProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:38'!
do
	product disable! !

WSProductCommand subclass: #WSEnableProductCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSEnableProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:39'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSEnableProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:38'!
do
	product enable! !

!WSProductCommand methodsFor: 'initialization' stamp: 'srh 1/25/2009 22:16'!
initializeWithProduct: aProduct
	product := aProduct.
	self initialize.
! !

WSProductCommand subclass: #WSSetPreviewCommand
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSSetPreviewCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:36'!
product: aProduct image: anImage
	^self basicNew
		initializeWithProduct: aProduct image: anImage;
		yourself! !

!WSSetPreviewCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:37'!
do
	product preview: image! !

!WSSetPreviewCommand methodsFor: 'initialization' stamp: 'srh 1/26/2009 13:36'!
initializeWithProduct: aProduct image: anImage
	image := anImage.
	self initializeWithProduct: aProduct.
	! !

WSCommand subclass: #WSShipOrderCommand
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSShipOrderCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:53'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSShipOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:57'!
do
	order ship! !

!WSShipOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:54'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder! !

Object subclass: #WSListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSListener subclass: #WSCartListener
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

!WSCartListener class methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:27'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself.! !

!WSCartListener methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:15'!
addToCart: aProduct 
	cart add: aProduct.! !

!WSCartListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:25'!
do: anAnnouncement
	 self addToCart: anAnnouncement product! !

!WSCartListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:26'!
handles
	^Array with: WSAddToCart ! !

!WSCartListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:26'!
initializeWithCart: aCart
	self initialize.
	cart := aCart.! !

WSListener subclass: #WSLightboxListener
	instanceVariableNames: 'root stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSLightboxListener class methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:19'!
root: aComponent
	^self basicNew
		initializeWithRoot: aComponent;
		yourself! !

!WSLightboxListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:19'!
do: anAnnouncement
	self lightbox: anAnnouncement component! !

!WSLightboxListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 12:15'!
handles
	^Array with: WSLightbox! !

!WSLightboxListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:18'!
initializeWithRoot: aComponent
	self initialize.
	root := aComponent.
	stack := Stack new.! !

!WSLightboxListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 10:08'!
lightbox: aComponent
	| target  result |
	target := stack isEmpty ifFalse: [ stack top ].
	stack push: aComponent.
	target isNil ifTrue: [
		result := root lightbox: aComponent.
	] ifFalse: [
		result := target call: aComponent.
	].
	stack pop.
	^result! !

!WSListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:17'!
do: anAnnouncement
	"Perform the appropriate action for an announcement"
	self subclassResponsibility! !

!WSListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:17'!
handles
	"Return a collection of Announccement classes this listener handles"
	^self subclassResponsibility! !

Object subclass: #WSObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

WSObject subclass: #WSAddress
	instanceVariableNames: 'address1 address2 postcode locality state country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 17:17'!
address1
	^address1! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:02'!
address1: anAddress
	address1 := anAddress.! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:05'!
address2
	^address2! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:05'!
address2: anAddress
	address2 := anAddress.! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
country
	^country! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
country: aCountry
	country := aCountry! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
locality
	^locality! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
locality: aLocality
	locality := aLocality! !

!WSAddress methodsFor: 'building' stamp: 'srh 1/1/2009 21:12'!
populateFrom: anAddress
	(WSAddress selectors reject: [ :s | s endsWith: ':']) do: [ :s |
		self perform: s asMutator with: (anAddress perform: s)]! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
postcode
	^postcode! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
postcode: aPostcode
	postcode := aPostcode! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
state
	^state! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:10'!
state: aState
	state := aState! !

WSAddress subclass: #WSShippingAddress
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSShippingAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 14:43'!
name
	^name! !

!WSShippingAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 14:46'!
name: aName
	name := aName! !

WSObject subclass: #WSCart
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCart methodsFor: 'adding' stamp: 'srh 1/4/2009 11:42'!
add: aProduct
	items add: aProduct! !

!WSCart methodsFor: 'enumerating' stamp: 'srh 1/2/2009 13:23'!
anySatisfy: aBlock
	^items anySatisfy: aBlock! !

!WSCart methodsFor: 'accessing' stamp: 'srh 12/31/2008 15:04'!
count
	^items size! !

!WSCart methodsFor: 'enumerating' stamp: 'srh 1/2/2009 09:50'!
do: aBlock
	items do: aBlock! !

!WSCart methodsFor: 'accessing' stamp: 'srh 12/31/2008 14:56'!
empty
	^(items size > 0) not! !

!WSCart methodsFor: 'initialization' stamp: 'srh 12/31/2008 14:48'!
initialize
	items := OrderedCollection new.! !

!WSCart methodsFor: 'accessing' stamp: 'srh 12/31/2008 14:50'!
items
	^items clone! !

!WSCart methodsFor: 'removing' stamp: 'srh 1/1/2009 14:20'!
remove: aProduct
	items remove: aProduct.! !

!WSCart methodsFor: 'accessing' stamp: 'srh 12/31/2008 14:51'!
totalInDollars
	|t|
	t := items inject: 0 into: [:a :i| a + i price].
	^(t / 100) asFloat.! !

WSObject subclass: #WSCustomer
	instanceVariableNames: 'email name phone address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCustomer class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:05'!
new
	^self basicNew
		initialize;
		yourself.! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:50'!
email
	^email! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:52'!
email: anEmailAddress
	email := anEmailAddress! !

!WSCustomer methodsFor: 'initialization' stamp: 'srh 2/22/2009 12:04'!
initialize
	super initialize.
	address := WSAddress new.! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:50'!
name
	^name! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:53'!
name: aName
	name := aName! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:51'!
phone
	^phone! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:52'!
phone: aPhoneNumber
	phone := aPhoneNumber! !

WSObject subclass: #WSImage
	instanceVariableNames: 'baseName'
	classVariableNames: 'Medium Thumb Extension'
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:41'!
initialize
	super initialize.
	Thumb := 50@50.
	Medium := 200@200.
	Extension := '.jpg'! !

WSImage subclass: #WSDummyImage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-TestResources'!

!WSDummyImage class methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 11:31'!
baseName: aName
	^self new
		baseName: aName;
		yourself.! !

!WSDummyImage methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 11:27'!
baseName: aString
	baseName := aString! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 22:42'!
fromStream: aStream
	^self basicNew
		initialize;
		generateImagesFrom: (ImageReadWriter formFromStream: aStream);
		yourself.
	! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:33'!
fullsize
	^ baseName, '-full' , Extension! !

!WSImage methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:33'!
generateImagesFrom: aForm.
	(aForm scaledToSize: Thumb) writeJPEGfileNamed: self path, self thumbnail.
	(aForm scaledToSize: Medium) writeJPEGfileNamed: self path, self medium.
	aForm writeJPEGfileNamed: self path, self fullsize.! !

!WSImage methodsFor: 'initialization' stamp: 'srh 1/4/2009 11:33'!
initialize
	super initialize.
	baseName := UUID new printString! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:33'!
medium
	^ baseName, '-med' , Extension! !

!WSImage methodsFor: 'class migration' stamp: 'srh 1/4/2009 18:01'!
migrate
	baseName class = UUID ifTrue: [
		baseName := baseName printString.	
	]! !

!WSImage methodsFor: 'accessing' stamp: 'srh 12/31/2008 08:32'!
path
	^'files/'! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:32'!
thumbnail
	^ baseName, '-thumb' , Extension! !

!WSObject methodsFor: 'class migration' stamp: 'srh 1/3/2009 09:42'!
migrate
	"Initialize new ivars added since the object was saved"
! !

WSObject subclass: #WSOption
	instanceVariableNames: 'name required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSOption class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:03'!
label
	^self subclassResponsibility! !

!WSOption methodsFor: '*webstore-components' stamp: 'srh 3/11/2009 13:55'!
editField
	^ self subclassResponsibility! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 00:15'!
name
	^name! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 11:01'!
name: aName
	name := aName.! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 00:16'!
required
	^required! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 11:01'!
required:  isRequired
	required := isRequired! !

WSOption subclass: #WSTextOption
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSTextOption class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:03'!
label
	^'Text'! !

!WSTextOption methodsFor: '*webstore-components' stamp: 'srh 3/11/2009 13:56'!
editField
	^WSField text on: #text of: self! !

!WSTextOption methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:10'!
text
	^text! !

!WSTextOption methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:10'!
text: someText
	text := someText! !

WSObject subclass: #WSOrder
	instanceVariableNames: 'items address customer status id history options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:35'!
address
	^address! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:37'!
address: aShippingAddress
	address := aShippingAddress! !

!WSOrder methodsFor: 'actions' stamp: 'srh 2/28/2009 14:13'!
cancel: reason
	status cancel: reason! !

!WSOrder methodsFor: 'actions' stamp: 'srh 2/28/2009 14:45'!
confirmPayment: reference
	status confirmPayment: reference! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:35'!
customer
	^customer! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:36'!
customer: aCustomer
	customer := aCustomer! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 2/28/2009 16:14'!
date
	"The order date is the date of the first #unconfirmed status"
	^(history detect: [:s | s is: #unconfirmed] 
		ifNone: [ self error: 'Order hasn''t been placed yet']
	) date.! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 2/28/2009 13:33'!
history
	^history! !

!WSOrder methodsFor: 'initialization' stamp: 'srh 3/7/2009 10:07'!
initialize
	super initialize.
	history := OrderedCollection new.
	options := OrderedCollection new.
	self status: (WSStatus newFor: self)! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:35'!
items
	^items! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:36'!
items: aCollectionOfProducts 
	items := aCollectionOfProducts! !

!WSOrder methodsFor: 'class migration' stamp: 'srh 2/28/2009 17:50'!
migrate
	super migrate.! !

!WSOrder methodsFor: 'actions' stamp: 'srh 2/28/2009 13:34'!
placeOrder: orderId
	status placeOrder.
	id := orderId.
! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/2/2009 12:13'!
reference
	^id! !

!WSOrder methodsFor: 'actions' stamp: 'srh 2/28/2009 13:34'!
ship
	status ship.! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/2/2009 08:59'!
status
	^status! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 2/28/2009 13:40'!
status: aStatus 
	status := aStatus.
	history add: aStatus! !

WSObject subclass: #WSProduct
	instanceVariableNames: 'name description price images preview enabled options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSProduct methodsFor: 'actions' stamp: 'srh 12/30/2008 21:20'!
addImage: anImage
	images add: anImage.
	images size = 1 ifTrue: [preview := anImage]! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/1/2009 10:11'!
customFields
	^#()! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:29'!
description
	^description! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:30'!
description: aDescription
	description := aDescription.! !

!WSProduct methodsFor: 'actions' stamp: 'srh 12/31/2008 09:58'!
disable
	enabled := false! !

!WSProduct methodsFor: 'actions' stamp: 'srh 12/31/2008 09:50'!
enable
	enabled := true! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/31/2008 09:50'!
enabled
	^enabled! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/8/2009 22:32'!
images
	^images clone! !

!WSProduct methodsFor: 'initialization' stamp: 'srh 3/7/2009 19:37'!
initialize
	images := OrderedCollection new.
	enabled := false.	
	options := OrderedCollection new.! !

!WSProduct methodsFor: 'class migration' stamp: 'srh 3/8/2009 21:47'!
migrate
	images do: [ :i | i migrate].
	options ifNil: [options := OrderedCollection new].
	options do: [ :o| o migrate].! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/28/2008 13:53'!
name
	^name.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/28/2008 13:53'!
name: aName
	name := aName.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/8/2009 22:32'!
options
	^options clone.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/8/2009 22:32'!
options: anOrderedCollection
	options := anOrderedCollection clone.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/30/2008 21:19'!
preview
	^preview! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/30/2008 21:24'!
preview: anImage
	(images includes: anImage) ifFalse: [
		self error: 'Preview image must be one of the product''s images'
	].
	preview := anImage! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:32'!
price
	^price! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:32'!
price: priceInCents
	price := priceInCents! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/30/2008 19:20'!
priceInDollars
	^(price / 100) asFloat! !

!WSProduct methodsFor: 'actions' stamp: 'srh 12/30/2008 21:22'!
removeImage: anImage
	images remove: anImage.
	preview = anImage ifTrue: [
		preview := images isEmpty ifTrue: [nil] ifFalse: [images first]]! !

!WSProduct methodsFor: 'actions' stamp: 'srh 3/7/2009 19:38'!
removeOption: anOption
	options remove: anOption! !

WSObject subclass: #WSStore
	instanceVariableNames: 'products orders orderId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSStore methodsFor: 'actions' stamp: 'srh 12/28/2008 13:48'!
addProduct: aProduct
	products add: aProduct.! !

!WSStore methodsFor: 'actions' stamp: 'srh 12/30/2008 14:45'!
deleteProduct: aProduct
	products remove: aProduct! !

!WSStore methodsFor: 'initialization' stamp: 'srh 1/2/2009 12:09'!
initialize
	super initialize.
	products := OrderedCollection new.
	orders := OrderedCollection new.
	orderId := 0.! !

!WSStore methodsFor: 'class migration' stamp: 'srh 2/28/2009 17:54'!
migrate
	"Initialize new ivars added since the object was saved"
	orderId ifNil: [orderId := 0].
	orders ifNil: [ orders := OrderedCollection new ].
	products do: [:p | p migrate].
	orders do: [:o | o migrate].
! !

!WSStore methodsFor: 'accessing' stamp: 'srh 1/3/2009 09:40'!
nextOrderId
	orderId := orderId + 1.
	^orderId printString.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 2/28/2009 14:55'!
orders
	^orders! !

!WSStore methodsFor: 'actions' stamp: 'srh 1/3/2009 09:39'!
placeOrder: anOrder
	anOrder placeOrder: self nextOrderId.
	orders add: anOrder.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 2/28/2009 14:56'!
products
	^products.! !

Object subclass: #WSProductPreview
	instanceVariableNames: 'product parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductPreview class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 16:16'!
product: aProduct parent: parent
	^self basicNew 
		initializeWithProduct: aProduct parent: parent;
		yourself.! !

!WSProductPreview methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 16:20'!
initializeWithProduct: aProduct parent: aComponent
	product := aProduct.
	parent := aComponent.
	super initialize.! !

!WSProductPreview methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:43'!
renderOn: html
	html div class: 'product-preview'; with: [
		html anchor callback: [parent call: (WSProductDetails for: product)]; with: [
			product preview ifNotNil: [html wsImage: product preview thumbnail].
		].
		html paragraph: '$', product priceInDollars printString.
		html paragraph: [html anchor callback: [parent lightbox: (WSAddOrderItem product: product)]; with: 'Add to Order'].
		html heading level: 3; with: [
				html anchor callback: [ parent call: (WSProductDetails for: product) ]; with: product name]].! !

Object subclass: #WSRule
	instanceVariableNames: 'rule message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSRule class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 17:41'!
rule: aBlock message: aMessage
	^self basicNew
		initializeWithRule:  aBlock message: aMessage;
		yourself.! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 17:42'!
initializeWithRule: aRule message: aMessage
	message := aMessage.
	rule := aRule.
	self initialize! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 19:02'!
message
	^message! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 19:02'!
rule
	^rule! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 19:04'!
testRule: value
	^rule value: value! !

Object subclass: #WSStatus
	instanceVariableNames: 'date owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSStatus commentStamp: 'srh 2/28/2009 11:22' prior: 0!
A WSStatus represents the current status of an order

Instance Variables
	date:		<Object>
	owner:		<WSOrder> (or, technically anything implementing #state:)
date
	- The date and time the current status was entered
	
owner
	- The class 'owning' this state. #state: is called on this class to change its state.
!

WSStatus subclass: #WSCancelledStatus
	instanceVariableNames: 'reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCancelledStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:00'!
owner: anObject
	self shouldNotImplement.! !

!WSCancelledStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:00'!
owner: anObject reason: aString
	^self basicNew
		initializeWithOwner: anObject reason: aString;
		yourself! !

!WSCancelledStatus methodsFor: 'initialization' stamp: 'srh 2/28/2009 13:59'!
initializeWithOwner: anOwner reason: aString
	self initializeWithOwner: anOwner.
	reason := aString.! !

!WSCancelledStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#cancelled! !

!WSCancelledStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 13:59'!
reason
	^reason! !

WSStatus subclass: #WSConfirmedStatus
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSConfirmedStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:33'!
owner: anObject
	^self shouldNotImplement! !

!WSConfirmedStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:33'!
owner: anObject reference: aString
	^self basicNew
		initializeWithOwner: anObject reference: aString;
		yourself.! !

!WSConfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:01'!
cancel: reason
	^ owner status: (WSCancelledStatus owner: owner reason: reason)! !

!WSConfirmedStatus methodsFor: 'initialization' stamp: 'srh 2/28/2009 12:34'!
initializeWithOwner: anOwner reference: aString
	self initializeWithOwner: anOwner.
	reference := aString.! !

!WSConfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#confirmed! !

!WSConfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 12:34'!
reference
	^reference! !

!WSConfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 13:40'!
ship
	^ owner status: (WSShippedStatus owner: owner)! !

WSStatus subclass: #WSNewStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSNewStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:01'!
name
	^#new! !

!WSNewStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 13:40'!
placeOrder
	^ owner status: (WSUnconfirmedStatus owner: owner)! !

WSStatus subclass: #WSShippedStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSShippedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#shipped! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:47'!
new
	self shouldNotImplement.! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:48'!
newFor: anOwner
	^WSNewStatus owner: anOwner! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:21'!
owner: anObject
	^self basicNew
		initializeWithOwner: anObject;
		yourself.! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:39'!
cancel: reason
	^self invalidStateChange: #cancel! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 12:39'!
confirmPayment: aReference
	^self invalidStateChange: #confirmPayment! !

!WSStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:06'!
date
	^date! !

!WSStatus methodsFor: 'initialization' stamp: 'srh 3/9/2009 11:12'!
initializeWithOwner: anObject
	self initialize.
	owner := anObject.
	date := DateAndTime now.
! !

!WSStatus methodsFor: 'error handling' stamp: 'srh 2/28/2009 11:28'!
invalidStateChange: aSymbol
	self error: 'The message ', aSymbol printString, ' does not make sense for the state ', self name printString! !

!WSStatus methodsFor: 'testing' stamp: 'srh 2/28/2009 11:05'!
is: aSymbol
	^self name = aSymbol! !

!WSStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 10:59'!
name
	^self subclassResponsibility.! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 11:29'!
placeOrder
	^self invalidStateChange: #placeOrder! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 11:30'!
ship
	^self invalidStateChange: #ship! !

WSStatus subclass: #WSUnconfirmedStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSUnconfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:07'!
cancel: reason
	^ owner status: (WSCancelledStatus owner: owner reason: reason)! !

!WSUnconfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 13:40'!
confirmPayment: aReference 
	^ owner status: (WSConfirmedStatus 
			owner: owner
			reference: aReference)! !

!WSUnconfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#unconfirmed! !

Object subclass: #WSTestingStore
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-TestResources'!

!WSTestingStore class methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:36'!
new
	^self basicNew
		initialize;
		yourself.! !

!WSTestingStore class methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:37'!
store
	^self new store! !

!WSTestingStore methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:57'!
addOrders
	store placeOrder: (WSOrder new
		customer: (WSCustomer new
			name: 'Customer1';
			email: 'cust1@example.com';
			yourself);
		address: (WSShippingAddress new
			name: 'o1 recipient';
			address1: 'o1 Ship address 1';
			address2: 'o1 Ship address 2';
			locality: 'o1 Suburb';
			state: 'o1 State';
			postcode: 'o1 1234';
			country: 'o1 Australia';
			yourself);
		items: (WSCart new
			add: store products first;
			add: (store products at: 4);
			yourself)).

	store placeOrder: (WSOrder new
		customer: (WSCustomer new
			name: 'Customer2';
			email: 'cust2@example.com';
			yourself);
		address: (WSShippingAddress new
			name: 'recipient';
			address1: 'Ship address 1';
			address2: 'Ship address 2';
			locality: 'Suburb';
			state: 'State';
			postcode: '1234';
			country: 'Australia';
			yourself);
		items: (WSCart new
			add: store products first;
			add: store products first)).
	store orders second cancel: 'because'.
	store placeOrder: (WSOrder new
		customer: (WSCustomer new
			name: 'Customer1';
			email: 'cust1@example.com';
			yourself);
		address: (WSShippingAddress new
			name: 'recipient';
			address1: 'Ship address 1';
			address2: 'Ship address 2';
			locality: 'Suburb';
			state: 'State';
			postcode: '1234';
			country: 'Australia';
			yourself);
		items: (WSCart new
			add: store products first;
			add: store products first)).
		store orders last confirmPayment: '1234'.
	store placeOrder: (WSOrder new
		customer: (WSCustomer new
			name: 'Customer4';
			email: 'cust4@example.com';
			yourself);
		address: (WSShippingAddress new
			name: 'o4 recipient';
			address1: 'o4 Ship address 1';
			address2: 'o4 Ship address 2';
			locality: 'Suburb';
			state: 'State';
			postcode: '1234';
			country: 'Australia';
			yourself);
		items: (WSCart new
			add: store products first;
			add: store products second)).
		store orders last confirmPayment: '1234'; ship.! !

!WSTestingStore methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:52'!
addProducts
	store addProduct: (WSProduct new
		name: 'Test product 1';
		description:  'Product description 1';
		price: 12345;
		enable;
		addImage: (WSDummyImage baseName: 'p1-i1');
		addImage: (WSDummyImage baseName: 'p1-i2');
		addImage: (WSDummyImage baseName: 'p1-i3');		
		yourself).

	store addProduct: (WSProduct new
		name: 'Test product 2';
		description:  'Product description 2';
		price: 33000;
		enable;
		addImage: (WSDummyImage baseName: 'p2-i1');
		yourself).
	store addProduct: (WSProduct new
		name: 'Test product 3';
		description:  'Product description 3';
		price: 44000;
		addImage: (WSDummyImage baseName: 'p3-i1');
		disable;
		yourself).
		
	store addProduct: (WSProduct new
		name: 'Test product 4';
		description:  'Product description 4';
		price: 12345;
		enable;
		addImage: (WSDummyImage baseName: 'p4-i1');
		addImage: (WSDummyImage baseName: 'p4-i2');
		addImage: (WSDummyImage baseName: 'p4-i3');		
		yourself).! !

!WSTestingStore methodsFor: 'as yet unclassified' stamp: 'srh 1/31/2009 18:53'!
initialize
	super initialize.
	store := WSStore new.
	self addProducts.
	self addOrders.
! !

!WSTestingStore methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:33'!
store
	^store! !

Object subclass: #WSTransactionalStub
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-TestResources'!

!WSTransactionalStub methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 00:35'!
abort! !

!WSTransactionalStub methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 00:35'!
commit: aBlock
	aBlock value! !

WAComponent subclass: #WSCancelableInputDialog
	instanceVariableNames: 'message value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSCancelableInputDialog class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:05'!
message: aMessage
	^self basicNew
		initializeWithMessage: aMessage;
		yourself! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 11:13'!
initializeWithMessage: aMessage
	self initialize.
	message := aMessage.! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:07'!
renderContentOn: html
	html heading level: 3; with: message.
	html form
		defaultAction: [self submit];
		with: [
			html textInput on: #value of: self.
			html space.
			html submitButton value: 'Ok';
				callback: [ self submit].
			html space.
			html cancelButton value: 'Cancel'; callback: [self answer: nil] ]! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:07'!
submit
	(value notNil and: [value notEmpty ]) ifTrue: [
		self answer: value] 
! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:08'!
value
	^value! !

!WSCancelableInputDialog methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:07'!
value: aValue
	value := aValue.! !

WAComponent subclass: #WSCheckoutWizard
	instanceVariableNames: 'page order pages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCheckoutWizard methodsFor: 'as yet unclassified' stamp: ''!
children! !

!WSCheckoutWizard methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 10:34'!
goToFirstPage
	page := pages first! !

!WSCheckoutWizard methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:30'!
initialize
	super initialize.
	page := WSCustomerPage new.
	pages := OrderedCollection new
		add: WSCartViewPage new;
		add: page;
		add: WSShippingAddressPage new;
		add: WSConfirmOrderPage new;
		yourself.
	order := WSOrder new.
	order items: self session cart.
	pages do: [ :p | p model: order ].
	page onEnter.! !

!WSCheckoutWizard methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:07'!
renderButtonsOn: html 
	html div class: 'nav-buttons'; with: 
		[ html cancelButton
			callback: [ self answer: nil ];
			value: 'Cancel'.
		html space.
		page = pages first ifFalse: 
			[ html cancelButton
				callback: [ page := pages before: page ];
				value: 'Previous' ].
		html space.
		page = pages last 
			ifFalse: 
				[ html submitButton
					callback: 
						[ (page save and: [ page valid ]) ifTrue: [ page := pages after: page. page onEnter ] ];
					value: 'Next' ]
			ifTrue: 
				[ html submitButton
					callback: [ (page save and: [ page valid ]) ifTrue: [ self answer: order ] ];
					value: 'Pay with Paypal' ] ]! !

!WSCheckoutWizard methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:31'!
renderContentOn: html
	self renderNavOn: html.
	self renderTitleOn: html.
	html form: [
		html render: page.
		self renderButtonsOn: html
	]! !

!WSCheckoutWizard methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:46'!
renderNavOn: html 
	html unorderedList
		class: 'wizard-tabs';
		with: 
			[ pages do: 
				[ :p | 
				html listItem
					class: (p enabled ifFalse: [ 'disabled' ]);
					with: 
						[ (p = page or: [ p enabled not ]) 
							ifTrue: [ html text: p title ]
							ifFalse: 
								[ html anchor
									callback: [ page := p ];
									with: p title ] ] ] ]! !

!WSCheckoutWizard methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 12:57'!
renderTitleOn: html
	html heading: page title! !

WAComponent subclass: #WSComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

WSComponent subclass: #WSCartView
	instanceVariableNames: 'cart parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartView class methodsFor: 'as yet unclassified' stamp: 'srh 3/14/2009 11:26'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself! !

!WSCartView class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:53'!
new
	self shouldNotImplement! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 13:57'!
cart
	^cart! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 10:09'!
editItem: aProductEntry
	self lightbox: (WSEditOrderItem product: aProductEntry )! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 3/14/2009 11:26'!
initializeWithCart: aCart
	cart := aCart.
	self initialize.
! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 3/12/2009 20:48'!
renderContentOn: html
	html div class: 'cart-view'; with: [
		html table: [
		html tableRow: [
			html tableHeading colSpan: 2; with: 'Item'.
			html tableHeading: 'Price'.
			html tableHeading].
		html tableBody id: 'cart-items'; with: [
		self cart items do: [ :p | html tableRow: [
			html tableData: [
				p preview ifNotNil: [ html image resourceUrl: WSImageLibrary path, p preview thumbnail]].
			html tableData: [ html anchor callback: [ self editItem: p]; with: p name].
			html tableData: '$', p priceInDollars printString.
			html tableData: [ html anchor callback: [self cart remove: p]; with: 'Remove']]]
		].
		html tableRow: [
			html tableData.
			html tableData: 'Total: '.
			html tableHeading id: 'cart-total'; with: '$', self cart totalInDollars printString.
			html tableData.
		]
	]].
! !

WSComponent subclass: #WSCartViewDialog
	instanceVariableNames: 'cartView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartViewDialog class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:44'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself! !

!WSCartViewDialog class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:44'!
new
	self shouldNotImplement! !

!WSCartViewDialog methodsFor: 'accessing' stamp: 'srh 1/1/2009 10:59'!
children
	^Array with: cartView.! !

!WSCartViewDialog methodsFor: 'accessing' stamp: 'srh 3/21/2009 12:50'!
initializeWithCart: aCart
	self initialize.
	cartView := WSCartView cart: aCart! !

!WSCartViewDialog methodsFor: 'rendering' stamp: 'srh 1/4/2009 19:15'!
renderContentOn: html
		html heading level:1; with: 'Current Order'.
		html render: cartView.
		html div class: 'nav-buttons'; with: [
		html anchor callback: [ self answer]; with: 'Back'.
		html text: ' '.
		html anchor callback: [ self answer: (self call: WSCheckoutProcess new) ]; with: 'Checkout'.
	]! !

WSComponent subclass: #WSCartWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartWidget methodsFor: 'accessing' stamp: 'srh 12/31/2008 14:34'!
cart
	^self session cart.! !

!WSCartWidget methodsFor: 'rendering' stamp: 'srh 3/10/2009 21:40'!
renderContentOn: html
	html div class: 'cart-widget'; with: [	self cart empty ifFalse: [
		html heading level: 3; with: 'Your Order'.
		html paragraph: 'Items: ', self cart count printString, ' Total: $', self cart totalInDollars printString.
		html paragraph: [
			html anchor callback: [self lightbox: (WSCartViewDialog cart: self cart)]; with: 'Review']]]! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:27'!
announce: anAnnouncement
	^self session announce: anAnnouncement! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:27'!
lightbox: aComponent
	self announce: (WSLightbox component: aComponent)! !

WSComponent subclass: #WSEditOrderItem
	instanceVariableNames: 'product form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

WSEditOrderItem subclass: #WSAddOrderItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:21'!
addProduct: aProduct
	self announce: (WSAddToCart product: aProduct)! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:20'!
beforeAnswer
	self addProduct: product! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:41'!
buttonText
	^'Add to Order'! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:18'!
initializeWithProduct: aProduct
	super initializeWithProduct: aProduct.! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:40'!
title
	^'Add Item'! !

!WSEditOrderItem class methodsFor: 'as yet unclassified' stamp: 'srh 3/12/2009 22:04'!
addProduct: aProduct
	^self basicNew
		initializeWithProduct: aProduct title: 'Add Product';
		yourself.! !

!WSEditOrderItem class methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:24'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:20'!
beforeAnswer
	"nothing!!"
	! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:38'!
buttonText
	^'Save'! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/12/2009 22:07'!
cancel
	^self answer: nil! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:46'!
children
	^Array with: form.! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:46'!
initializeWithProduct: aProduct
	self initialize.
	form := WSForm new.
	product := aProduct.
	self setUpFields! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:30'!
renderContentOn: html
		html heading level:1; with: self title.
		html form id: 'add-item'; with: [
		self renderItemOn: html.
		html div class: 'nav-buttons'; with: [
		html submitButton callback: [ self saveAndAnswer ]; with:self buttonText.
		html text: ' '.
		html cancelButton callback: [ self cancel]; with: 'Cancel']]! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'cmd 3/21/2009 16:06'!
renderItemOn: html
	html div class: 'item'; with: [
		product preview ifNotNil: [html wsImage: product preview thumbnail.].
	html paragraph: product name.
	].
	html render: form! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:20'!
saveAndAnswer
	form valid ifTrue: [
		form save.
		self beforeAnswer..
		self answer: product
	].! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/12/2009 22:13'!
setUpFields
	product options do: 
		[ :o | 
		| field |
		field := o editField
			label: o name;
			yourself.
		o required ifTrue: [ field beRequired ].
		form add: field ]! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:38'!
title
	^'Edit Item'! !

WSComponent subclass: #WSProductDetails
	instanceVariableNames: 'product imageViewer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductDetails class methodsFor: 'as yet unclassified' stamp: 'srh 12/29/2008 17:54'!
for: aProduct
	^self basicNew
		product: aProduct;
		initialize;
		yourself.! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:53'!
children
	^Array with: imageViewer.! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:52'!
initialize
	super initialize.
	imageViewer := WSProductImageView for: product.! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 12/29/2008 17:55'!
product: aProduct
	product := aProduct.! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:59'!
renderContentOn: html
	html div class: 'product-details'; with: [
		html render: imageViewer.
		html heading level: 2; with: product name.
		html paragraph with: '$', product priceInDollars printString.
		html paragraph with: product description.
		html anchor callback: [ self answer ]; with: 'Back'
	].! !

WSComponent subclass: #WSProductImageView
	instanceVariableNames: 'current product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductImageView class methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:54'!
for: aProduct
	^self basicNew
		product: aProduct;
		initialize;
		yourself.! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:54'!
initialize
	super initialize.
	current := product preview.! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:55'!
product: aProduct
	product := aProduct.! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 22:02'!
renderContentOn: html 
	product images ifEmpty: [ ^ self ].
	html div
		class: 'image-viewer';
		with: 
			[ html anchor
				resourceUrl: WSImageLibrary path , current fullsize;
				with: [ html wsImage: current medium ].
			html unorderedList: 
				[ (product images reject: [ :i | i = current ]) do: 
					[ :i | 
					html listItem: 
						[ html anchor
							callback: [ current := i ];
							with: [ html wsImage: i thumbnail ] ] ] ] ]! !

WSComponent subclass: #WSProductList
	instanceVariableNames: 'products'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductList class methodsFor: 'as yet unclassified' stamp: 'srh 1/2/2009 17:24'!
products: aCollection
	^self basicNew
		products: aCollection;
		initialize.! !

!WSProductList methodsFor: 'as yet unclassified' stamp: 'srh 1/2/2009 17:24'!
products: aCollection
	products := aCollection
	! !

!WSProductList methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 16:23'!
renderContentOn: html
	(products select: [:p | p enabled]) 
		do: [ :p| html render: (WSProductPreview product: p parent: self)]! !

WAComponent subclass: #WSComponentHolder
	instanceVariableNames: 'preview children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSComponentHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 16:06'!
add: aComponent
	children add: aComponent! !

!WSComponentHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:43'!
announce: anAnnouncement
	^self session announce: anAnnouncement! !

!WSComponentHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 16:35'!
children
	^children select: [ :c | c isKindOf: WAComponent ]! !

!WSComponentHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:35'!
initialize
	super initialize.
	children := OrderedCollection new.
	self session on: WSLightbox do: [:ann| self lightbox: ann component ]! !

!WSComponentHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 16:07'!
renderContentOn: html
	children do: [ :c | html render: c ]! !

WAComponent subclass: #WSFieldHolder
	instanceVariableNames: 'fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Util'!

!WSFieldHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:41'!
add: aField
	fields add: aField! !

!WSFieldHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:40'!
children
	^fields! !

!WSFieldHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:40'!
initialize
	super initialize.
	fields := OrderedCollection new.! !

!WSFieldHolder methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 12:56'!
renderContentOn: html
	html form: [
		fields do: [ :field | html render: field ].
		html submitButton value: 'Save'; callback: [ fields do: [ :field | field save ]]]! !

WAComponent subclass: #WSFormElement
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSFormElement subclass: #WSDisplayElement
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSDisplayElement class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 13:01'!
value: anObject
	^self basicNew
		initializeWithValue: anObject;
		yourself.! !

!WSDisplayElement methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 13:02'!
initializeWithValue: anObject
	value := anObject.
	self initialize.! !

!WSDisplayElement methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 13:02'!
renderContentOn: html
	html text: value displayString.! !

!WSDisplayElement methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 13:03'!
value
	^value! !

WSFormElement subclass: #WSField
	instanceVariableNames: 'value selector receiver tag label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 16:21'!
checkbox
	^self basicNew
		tagType:  #checkbox;
		initialize;
		yourself.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:50'!
image
	^WSImageField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 10:28'!
integer
	^WSIntegerField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:57'!
largeText
	^self basicNew
		tagType:  #textArea;
		initialize;
		yourself.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:15'!
money
	^WSMoneyField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:43'!
numeric
	^WSNumericField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:13'!
text
	^self basicNew
		tagType:  #textInput;
		initialize;
		yourself.! !

!WSField methodsFor: 'accessing' stamp: 'srh 1/26/2009 14:24'!
beRequired
	"Nil is allowed, because the only time it'll be nil is when the form is first rendered"
	self addRule: [ :v| v isNil or: [v notEmpty]] withDescription: self label, ' is a required field'.! !

!WSField methodsFor: 'accessing' stamp: 'srh 1/26/2009 14:24'!
label
	^label ifNil:[label := selector asCapitalizedPhrase]! !

!WSField methodsFor: 'accessing' stamp: 'srh 12/30/2008 17:05'!
label: aString
	label := aString! !

!WSField methodsFor: 'accessing' stamp: 'srh 12/30/2008 19:06'!
messages
	^rules select: [ :r | (r testRule: value) not] thenCollect: [ :r | r message ] ! !

!WSField methodsFor: 'callbacks' stamp: 'srh 3/8/2009 21:43'!
on: aSelector of: aReceiver 
	selector := aSelector.
	receiver := aReceiver.
	self readInitialValue! !

!WSField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector! !

!WSField methodsFor: 'rendering' stamp: 'srh 3/8/2009 22:41'!
renderContentOn: html
	html div class: (self valid ifFalse: ['error']); with: [
		| id |
		id := html nextId.
		html label for: id; with: self label, ':'.
		(html perform: tag) 
			id: id;
			callback: [ :v| value := v];
			value: value
		]! !

!WSField methodsFor: 'actions' stamp: 'srh 3/9/2009 12:12'!
save
	receiver perform: selector asMutator with: value! !

!WSField methodsFor: 'accessing' stamp: 'srh 12/30/2008 17:01'!
tagType: symbol
	tag := symbol! !

!WSField methodsFor: 'testing' stamp: 'srh 3/9/2009 12:12'!
valid
	^rules allSatisfy: [ :r | r  testRule: value ].! !

!WSField methodsFor: 'accessing' stamp: 'srh 1/1/2009 20:55'!
value
	^value! !

WSField subclass: #WSFieldGroup
	instanceVariableNames: 'list labels newItemBlock componentBlock selectedItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/8/2009 23:51'!
addItem: aTemplate
	value add: (self componentForItem: (self itemForTemplate: aTemplate))! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 21:37'!
children
	^value select: [ :i | i isKindOf: WAComponent]! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 23:41'!
component: aBlock
	componentBlock := aBlock! !

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/9/2009 13:02'!
componentForItem: anItem
	^componentBlock
			ifNil: [ WSDisplayElement value: anItem ]
			ifNotNil: [ componentBlock value: anItem ]! !

!WSFieldGroup methodsFor: 'initialization' stamp: 'srh 3/9/2009 00:00'!
initialize
	value := OrderedCollection new.
	super initialize.! !

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/8/2009 23:50'!
itemForTemplate: template
	^newItemBlock 
			ifNil: [ template ]
			ifNotNil: [ newItemBlock value: template ]! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 09:58'!
labels: aBlock
	labels := aBlock! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 09:46'!
list: anOrderedCollection
	list := OrderedCollection new addAll: anOrderedCollection; yourself! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/9/2009 12:30'!
messages
		| messages |
		messages := OrderedCollection new.
		value do: [:f | messages addAll: f messages ].
		^messages
! !

!WSFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 23:40'!
newItem: aBlock 
	newItemBlock := aBlock! !

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/9/2009 12:40'!
readInitialValue
	value := ((receiver perform: selector) collect: [ :i | self componentForItem: i]) asOrderedCollection! !

!WSFieldGroup methodsFor: 'actions' stamp: 'srh 3/8/2009 21:49'!
removeItem: anItem 
	^ value remove: anItem! !

!WSFieldGroup methodsFor: 'rendering' stamp: 'srh 3/9/2009 11:26'!
renderContentOn: html 
	html fieldSet: 
		[ | s |
		html legend: label.
		s := html select.
		s
			list: list;
			callback: [ :t | selectedItem := t ].
		labels ifNotNil: [ s labels: labels ].
		html submitButton
			value: 'Add';
			callback: [ self addItem: selectedItem ].
		self renderItemsOn: html ]! !

!WSFieldGroup methodsFor: 'rendering' stamp: 'srh 3/8/2009 23:45'!
renderItemsOn: html 
	value size = 0 ifTrue: [ ^ self ].
	html table: 
		[ value do: 
			[ :i | 
			html tableRow: 
				[ html tableData: [ html render: i ].
				html tableData: 
					[ html submitButton
						value: 'Remove';
						callback: [ self removeItem: i ] ] ] ] ]! !

!WSFieldGroup methodsFor: 'rendering' stamp: 'srh 3/9/2009 12:10'!
save
	value do: [ :component | component save ].
	receiver perform: selector asMutator with: (value collect: [ :component | component value]).! !

!WSFieldGroup methodsFor: 'testing' stamp: 'srh 3/9/2009 12:13'!
valid
	^value allSatisfy: [ :i | i valid ]! !

WSField subclass: #WSImageField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSImageField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:55'!
new
	^self basicNew
		tagType: #fileUpload;
		initialize;
		yourself.! !

!WSImageField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	"Can't do anything sensible here"
	! !

WSField subclass: #WSIntegerField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSIntegerField class methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 10:24'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSIntegerField methodsFor: 'initialization' stamp: 'srh 12/31/2008 10:30'!
initialize
	super initialize.
	self addRule: [ :v | v asInteger notNil ] withDescription: 'Must be a number'.! !

!WSIntegerField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := value printString ]! !

!WSIntegerField methodsFor: 'actions' stamp: 'srh 3/9/2009 12:13'!
save
	receiver perform: selector asMutator with: value asInteger! !

WSField subclass: #WSMoneyField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSMoneyField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:18'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSMoneyField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := (value / 100) asFloat printString ]! !

!WSMoneyField methodsFor: 'actions' stamp: 'srh 3/9/2009 12:13'!
save
	receiver perform: selector asMutator with: ((value asNumber) * 100) asInteger! !

WSField subclass: #WSNumericField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSNumericField class methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:42'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSNumericField methodsFor: 'initialization' stamp: 'srh 3/11/2009 20:38'!
initialize
	super initialize.
	self addRule: [ :v | v isNil or: [v asNumber notNil] ] withDescription: 'Must be a number'.! !

!WSNumericField methodsFor: 'initialization' stamp: 'srh 3/11/2009 14:42'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := value printString ]! !

!WSNumericField methodsFor: 'actions' stamp: 'srh 3/11/2009 14:43'!
save
	receiver perform: selector asMutator with: value asNumber! !

WSField subclass: #WSTestingField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-Commands'!

!WSTestingField methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:07'!
value: newValue
	value := newValue.! !

WSFormElement subclass: #WSForm
	instanceVariableNames: 'fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSForm methodsFor: 'adding' stamp: 'srh 1/1/2009 15:36'!
add: aField
	fields add: aField! !

!WSForm methodsFor: 'accessing' stamp: 'srh 1/1/2009 15:17'!
children
	^fields! !

!WSForm methodsFor: 'initialization' stamp: 'srh 3/8/2009 22:47'!
initialize
	super initialize.
	fields := OrderedCollection new.! !

!WSForm methodsFor: 'accessing' stamp: 'srh 1/1/2009 20:22'!
messages
	^rules select: [ :r | (r testRule: self) not] thenCollect: [ :r | r message ] .! !

!WSForm methodsFor: 'rendering' stamp: 'srh 1/1/2009 15:20'!
renderContentOn: html
	self renderMessagesOn: html.
	fields do: [:f | html render: f].
! !

!WSForm methodsFor: 'rendering' stamp: 'srh 3/11/2009 21:16'!
renderMessagesOn: html 
	| messages |
	self valid ifTrue: [ ^ self ].
	messages := OrderedCollection new.
	messages addAll: self messages.
	fields do: [ :f | messages addAll: f messages ].
	html unorderedList class: 'error-msgs'; with: [ messages do: [ :m | html listItem: m ] ]! !

!WSForm methodsFor: 'actions' stamp: 'srh 3/9/2009 12:13'!
save
	fields do: [:f | f save]! !

!WSForm methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 21:43'!
updateFromModel
	fields do: [ :f | f readInitialValue ]! !

!WSForm methodsFor: 'testing' stamp: 'srh 3/9/2009 12:13'!
valid
	^(fields allSatisfy: [:f | f valid]) and: [rules allSatisfy: [:r | r testRule: self]]! !

WSForm subclass: #WSOptionField
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOptionField class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:02'!
option: anOption
	^self basicNew
		initializeWithOption: anOption;
		yourself! !

!WSOptionField methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 12:14'!
initializeWithOption: anOption
	self initialize.
	option := anOption.
	self add: (WSLabel label: option class label).
	self add: (WSField text label: 'Name'; on: #name of: option; beRequired; yourself).
	self add: (WSField checkbox label: 'Required'; on: #required of: option; yourself).! !

!WSOptionField methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 00:21'!
value
	^option! !

!WSFormElement methodsFor: 'adding' stamp: 'srh 3/8/2009 22:45'!
addRule: aBlock withDescription: desc.
	rules add: (WSRule rule: aBlock message: desc)! !

!WSFormElement methodsFor: 'adding' stamp: 'srh 3/8/2009 22:46'!
initialize
	super initialize.
	rules := OrderedCollection new.! !

!WSFormElement methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:27'!
messages
	^#()! !

!WSFormElement methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:21'!
save! !

!WSFormElement methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:21'!
valid
	^true! !

WSFormElement subclass: #WSLabel
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSLabel class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:23'!
label: aLabel
	^self basicNew
		initializeWithLabel: aLabel;
		yourself! !

!WSLabel methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:25'!
initializeWithLabel: aLabel 
	self initialize.
	label := aLabel! !

!WSLabel methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:23'!
renderContentOn: html 
	html label: label! !

WAComponent subclass: #WSImageEditor
	instanceVariableNames: 'image imageField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSImageEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:54'!
image: anImage
	^self basicNew
		initializeWithImage: anImage;
		yourself.! !

!WSImageEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:54'!
new
	^self image: nil! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 21:57'!
children
	^Array with: imageField! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 15:07'!
imageFile: aWAFile
	aWAFile ifNotNil: [
		image := WSImage fromStream: (ReadStream on: aWAFile contents asByteArray)]! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:56'!
initializeWithImage: anImage
	self initialize.
	image := anImage.
	imageField := WSField image
		label: 'Select an Image';
		on: #imageFile of: self;
		yourself.
! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:35'!
renderContentOn: html
	html form multipart; with: [
		html render: imageField.
		html div: [
			html cancelButton callback: [self answer: nil]; value: 'Cancel'.
			html submitButton callback: [self save]; value: 'Preview'.
			html submitButton callback: [self saveAndAnswer]; value: 'Done'	
		]
	].
	image ifNotNil: [
		html div: [
			html image resourceUrl: WSImageLibrary path, image thumbnail.
			html image resourceUrl: WSImageLibrary path, image medium.
		]		
	]

! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 15:35'!
save
	imageField valid ifTrue: [(WSApplyFormCommand form: imageField) run].	! !

!WSImageEditor methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 23:29'!
saveAndAnswer
	self save.
	self answer: image! !

WAComponent subclass: #WSImageManager
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSImageManager class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:55'!
for: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 21:39'!
addImage: anImage
	anImage ifNotNil: [product addImage: anImage].! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 00:33'!
delete: anImage
	(WSDeleteImageCommand product: product image: anImage) run.
! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 21:08'!
edit: anImage
	self call: (WSImageEditor image: anImage).
! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:56'!
initializeWithProduct: aProduct.
	self initialize.
	product := aProduct.! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 21:41'!
renderContentOn: html
	html anchor callback: [self addImage: (self call: WSImageEditor new)]; with: 'Add Image'.
	html text: ' '.
	html anchor callback: [self answer]; with: 'Done'.
	self renderImageListOn: html.! !

!WSImageManager methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:36'!
renderImageListOn: html
	product images do: [:i |
		html div: [
			html div 
				class: (product preview = i ifTrue: ['preview']); 
				with: [html image resourceUrl: WSImageLibrary path, i thumbnail].
			html div: [
				html anchor callback:  [product preview: i]; with: 'Set as Preview'.
				html text: ' '.
				html anchor callback: [self edit: i]; with: 'Edit'].
				html text: ' '.
				html anchor callback: [self delete: i]; with: 'Delete']]! !

WAComponent subclass: #WSOrderErrorPage
	instanceVariableNames: 'error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSOrderErrorPage class methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 10:30'!
error: anException
	^self basicNew
		error: anException;
		initialize;
		yourself.! !

!WSOrderErrorPage methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 10:30'!
error: anException
	error := anException! !

!WSOrderErrorPage methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:52'!
renderContentOn: html
	html heading: 'Order Failed'.
	html paragraph: 'An error ocurred while processing your order: ', error printString.
	html div class: 'nav-buttons'; with: [ html anchor callback: [self answer]; with: 'Back']! !

WAComponent subclass: #WSOrderManager
	instanceVariableNames: 'filter store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderManager class methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 13:47'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself.! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 22:04'!
formatDate: aDate
	^aDate asDate printFormat: #(3 2 1 - 1 1 2) ! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/2/2009 17:56'!
initializeWithStore: aStore
	store := aStore.
	self initialize.! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:42'!
orders
	^filter isNil 
		ifTrue: [store orders]
		ifFalse: [store orders select: [ :o | o status is: filter ]].! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:53'!
renderActionsOn: html
	html div: [
		html anchor callback: [self answer]; with: 'Done']! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 19:52'!
renderCancelActionFor: anOrder on: html 
	html anchor
		callback: [| reason | 
			reason := self call: (WSCancelableInputDialog message: 'Please enter a reason for cancelling the order').
			reason ifNotNil: [(WSCancelOrderCommand order: anOrder reason: reason) run]];
		 with: 'Cancel'! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:10'!
renderConfirmedActionsFor: anOrder on: html
	html anchor callback: [(self confirm: 'Ship Order?') ifTrue: [(WSShipOrderCommand order: anOrder) run]]; with: 'Ship'.
	html space.
	self renderCancelActionFor: anOrder on: html! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/2/2009 17:46'!
renderContentOn: html
	self renderActionsOn: html.
	self renderFilterOn: html.
	self renderOrderListOn: html! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:34'!
renderFilterOn: html
	html form: [ |id|
		id := html nextId.
		html label for: id; with: 'Show: '.
		html select 
			id: id; 
			beSubmitOnChange; 
			beOptional; 
			selected: filter;
			list: #(unconfirmed confirmed cancelled shipped);
			labels: [ :o | o asCapitalizedPhrase];
			optionalLabel: 'All';
			callback: [ :value | filter := value]]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:38'!
renderOrderListOn: html
	html table: [
		html tableRow: [
			html tableHeading: 'Reference'.
			html tableHeading: 'Customer'.
			html tableHeading: 'Items'.
			html tableHeading: 'Total'.
			html tableHeading: 'Date'.
			html tableHeading: 'Status'].
		self orders do: [ :o | html tableRow: [
			html tableData: o reference.
			html tableData: o customer name.
			html tableData: o items count printString.
			html tableData: '$', o items totalInDollars printString.
			html tableData: (self formatDate: o date).
			html tableData: [self renderStatus: o status on: html. self renderStatusActionsFor: o on: html]
		]]]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:39'!
renderStatus: aStatus on: html.
	html text: aStatus name asCapitalizedPhrase, ' (', (self formatDate: aStatus date), ')'.
! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 19:42'!
renderStatusActionsFor: anObject on: html
	| selector |
	selector := ('render', anObject status name displayString capitalized, 'ActionsFor:on:') asSymbol.
	(self respondsTo: selector) ifTrue: [
		self perform: selector with: anObject with: html]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:14'!
renderUnconfirmedActionsFor: anOrder on: html
	self renderCancelActionFor: anOrder on: html! !

WAComponent subclass: #WSOrderSuccess
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSOrderSuccess class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 14:31'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSOrderSuccess methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 11:13'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder.
! !

!WSOrderSuccess methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:47'!
renderContentOn: html
	html heading: 'Order Complete'.
	html paragraph: 'Your order was succesfully placed, and your reference number is: ', order reference.
	html div class: 'nav-buttons'; with: [
		html anchor callback: [self answer]; with: 'Close']! !

WAComponent subclass: #WSPayPalCheckout
	instanceVariableNames: 'order onSuccess onCancel url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSPayPalCheckout class methodsFor: 'as yet unclassified' stamp: 'srh 2/21/2009 17:18'!
new
	^self shouldNotImplement! !

!WSPayPalCheckout class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:51'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder
		yourself.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:15'!
initializeUrl
	url := WAUrl new.
	url scheme: #https.
	url addToPath: '/us/cgi-bin/webscr'.
	url hostname: (self preferenceAt: #paypalHost).
	url addParameter: 'business' value: (self preferenceAt: #accountEmail)! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:12'!
initializeWithOrder: anOrder
	order := anOrder.
	onSuccess := [].
	onCancel := [].
	self initializeUrl.
	self initialize.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 20:51'!
onCancel: aBlock
	onCancel := aBlock.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:52'!
onSuccess: aBlock
	onSuccess := aBlock.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 19:34'!
prepareUrlOn: html
	url addParameter: 'cmd' value: '_cart'.
	url addParameter: 'upload' value: '1'.
	url addParameter: 'address_override' value: '1'.
	url addParameter: 'business' value: (self preferenceAt: #accountEmail).
	url addParameter: 'currency_code' value: 'AUD'.
	url addParameter: 'first_name' value: (order customer name splitOn: ' ') first.
	url addParameter: 'last_name' value: (order customer name splitOn: ' ') last.
	url addParameter: 'address1' value: order address address1.
	url addParameter: 'address2' value: order address address2.
	url addParameter: 'city' value: order address locality.
	url addParameter: 'state' value: order address state.
	url addParameter: 'zip' value: order address postcode.
	url addParameter: 'country' value: order address country.
	url addParameter: 'rm' value: '2'.
	url addParameter: 'return' value: (html urlForAction: onSuccess).
	url addParameter: 'cancel_return' value: (html urlForAction: onCancel).
	order items items inject: 1 into: [:index :product|
		url addParameter: 'amount_', index printString value: product priceInDollars.
		url addParameter: 'item_name_', index printString value: product name.
	index + 1].! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:26'!
renderContentOn: html
	self prepareUrlOn: html.
	self session redirectTo: url displayString.! !

WAComponent subclass: #WSProductEditor
	instanceVariableNames: 'product fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSProductEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:49'!
new
	^self product: (WSProduct new).! !

!WSProductEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:49'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		initialize;
		yourself.! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 15:19'!
children
	^Array with: fields! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:47'!
initializeWithProduct: aProduct
	self initialize.
	product := aProduct.
	self setupFields.! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 15:20'!
renderContentOn: html
	html form: [
		html render: fields.
		html div: [
			html cancelButton value: 'Cancel'; callback: [ self answer: nil].
			html submitButton value: 'Save'; callback: [ self saveAndAnswer]
	]]! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:48'!
saveAndAnswer
	fields valid ifTrue: [
		(WSApplyFormCommand form: fields) run.
		self answer: product
	]! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 23:46'!
setupFields
	fields := WSForm new.
	fields add: (WSField text
			label: 'Name';
			on: #name
				of: product;
			beRequired).
	fields add: (WSField money
			label: 'Price';
			on: #price
				of: product;
			beRequired).
	fields add: (WSField largeText
			label: 'Description';
			on: #description
				of: product).
	fields add: (WSFieldGroup new
			label: 'Product Specific Fields';
			list: WSOption subclasses;
			labels: [ :item | item label ];
			newItem: [ :template | template new ];
			component: [ :item | WSOptionField option: item ];
			on: #options
				of: product)! !

WAComponent subclass: #WSProductManager
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSProductManager class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:49'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:43'!
addProduct
	| p |
	p := self call: WSProductEditor new.
	p ifNotNil: [	(WSAddProductCommand store: store product: p) run]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:44'!
deleteProduct: p
	(self confirm: 'Really delete ',p name, '?') ifTrue: [
		(WSDeleteProductCommand store: store product: p) run ]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 20:01'!
editProduct: aProduct 
	self call: (WSProductEditor product: aProduct)! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:51'!
initializeWithStore: aStore
	self initialize.
	store := aStore! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 20:24'!
manageImages: aProduct
	self call: (WSImageManager for: aProduct)! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 08:45'!
renderActionsOn: html
	html div: [
		html anchor callback: [ self addProduct]; with: 'Add Product'.
		html text: ' '.
		html anchor callback: [self answer]; with: 'Done']! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 13:24'!
renderContentOn: html
	self renderStatsOn: html.
	self renderActionsOn: html.
	self renderProductListOn: html.
	html paragraph: [
		html anchor callback: [ self answer ]; with: 'back']! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:45'!
renderProductListOn: html
	html table: [
		html tableRow: [
			html tableHeading.
			html tableHeading: 'Name'.
			html tableHeading: 'Price'.
			html tableHeading: 'Actions'	].
		store products do: [ :p| html tableRow: [
			html tableData: [
				p preview ifNotNil: [html image resourceUrl: WSImageLibrary path, p preview thumbnail]
			].		
			html tableData: p name.
			html tableData: p priceInDollars printString.
			html tableData: [ 
				html anchor callback: [ self deleteProduct: p ]; with: 'Delete'.
				html space.
				html anchor callback: [self editProduct: p]; with: 'Edit'.
				html space.
				html anchor callback: [self manageImages: p ]; with: 'Images'.
				html space.
				p enabled 
					ifTrue: [html anchor callback: [(WSDisableProductCommand product: p) run]; with: 'Disable']
					ifFalse: [html anchor callback: [(WSEnableProductCommand product: p) run]; with: 'Enable']]]]]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 20:25'!
renderStatsOn: html
	html div: [
		html paragraph: store products size printString, ' products']! !

WAComponent subclass: #WSRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSRoot subclass: #TestSite
	instanceVariableNames: 'products cartWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-TestSite'!

!TestSite class methodsFor: 'as yet unclassified' stamp: 'srh 12/28/2008 12:53'!
canBeRoot
	^true! !

!TestSite methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 14:30'!
children
	^Array with: products with: cartWidget.! !

!TestSite methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:40'!
initialize
	super initialize.
	products := WSProductList products: self store products.
	cartWidget := WSCartWidget new.
	self addListener: (WSCartListener cart: self session cart).! !

!TestSite methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 10:03'!
renderContentOn: html
	html heading id: 'banner'; with: 'Emma''s Store'.
	html div id: 'nav';with: [
		html unorderedList with: [
			html listItem: [ html anchor callback: []; with: 'Home'].
			html listItem: [ html anchor callback: []; with: 'A link'].
		].
		html render: cartWidget.
	].
	html div id: 'content';with:products! !

!TestSite methodsFor: 'as yet unclassified' stamp: 'srh 1/2/2009 17:26'!
store
	^self session store! !

!TestSite methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 12:58'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot	stylesheet 
		url: TestSiteFiles  / #webstoreCss! !

!WSRoot methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:36'!
addListener: aListener
	aListener handles do: [ :a |
		self session on: a do: [ :ann |  aListener do: ann ]]! !

!WSRoot methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 12:22'!
initialize
	super initialize.
	self addListener: (WSLightboxListener root: self).! !

WAComponent subclass: #WSStoreAdmin
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSStoreAdmin class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 11:51'!
canBeRoot
	^true! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 21:57'!
initialize
	super initialize.
	store := self session store.! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 09:49'!
menu: title callback: aBlock on: html
	html heading level: 2; with: [
	html anchor 
		callback: aBlock; 
		with: title].
! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 16:04'!
migrateStore
	self session commit: [store migrate].
	self inform: 'Migration Successful'! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 3/1/2009 18:56'!
renderContentOn: html 
	self 
		menu: 'Manage Products'
		callback: [ self call: (WSProductManager store: store) ]
		on: html.
	self 
		menu: 'Manage Orders'
		callback: [ self call: (WSOrderManager store: store) ]
		on: html.
	self 
		menu: 'Migrate Store'
		callback: [ self migrateStore ]
		on: html.
	self menu: 'Reset Store'
		callback: [self resetStore ]
		on: html.
	html heading
		level: 2;
		with: 
			[ html anchor
				resourceUrl: 'store';
				with: 'Go to Store' ]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 3/1/2009 18:58'!
resetStore
	(self confirm: 'This will Delete the entire store and cannot be undone - are you sure?') ifTrue: [
		self session magmaSession commit: [ self session magmaSession root at: #store put: WSStore new]]! !

WAComponent subclass: #WSWizardPage
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSWizardPage subclass: #WSBaseAddressPage
	instanceVariableNames: 'fields tempAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSBaseAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:21'!
addressClass
	^WSAddress! !

!WSBaseAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:13'!
children
	^Array with:fields! !

!WSBaseAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:21'!
initialize
	super initialize.
	tempAddress := self addressClass new.
	fields := WSForm new.
	self setupFields! !

!WSBaseAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:45'!
setupFields
	fields add: (WSField text 
		label: 'Address Line 1';
		on: #address1 of: tempAddress;
		beRequired;
		yourself).
	fields add: (WSField text 
		label: 'Address Line 2';
		on: #address2 of: tempAddress;
		yourself).
	fields add: (WSField text
		label: 'Suburb / Town';
		on: #locality of: tempAddress;
		yourself).
	fields add: (WSField text
		label: 'State / Province';
		on: #state of: tempAddress;
		beRequired;
		yourself).
	fields add: (WSField text
		label: 'Postcode';
		on: #postcode of: tempAddress;
		beRequired; 
		yourself).
	fields add: (WSField text
		label: 'Country';
		on: #country of: tempAddress;
		beRequired; 
		yourself).! !

WSBaseAddressPage subclass: #WSShippingAddressPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:22'!
addressClass
	^WSShippingAddress! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:35'!
enabled
	^model customer notNil! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:24'!
initialize
	super initialize.! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:51'!
onEnter
	model address ifNil: [
		tempAddress name: model customer name.
		fields updateFromModel.
	]! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:33'!
renderContentOn: html
	html div class: 'shipping-address'; with: fields.	! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:41'!
save
	fields valid 
		ifTrue: [
			fields save.
			model address: tempAddress.
			^true]
		ifFalse: [^false]! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:23'!
setupFields
	fields add: (WSField text 
		label: 'Name';
		on: #name of: tempAddress;
		beRequired).
	super setupFields.! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:26'!
title
	^'Shipping Address'! !

!WSShippingAddressPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:40'!
valid
	^model address notNil.! !

WSWizardPage subclass: #WSCartViewPage
	instanceVariableNames: 'cartView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 18:57'!
children
	^Array with: cartView! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:53'!
enabled
	^true! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 15:00'!
initialize
	super initialize.
! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 15:01'!
model: anObject
	super model: anObject.
	cartView := WSCartView cart: model items! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:22'!
renderContentOn: html
	html render: cartView! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:19'!
title
	^'Review Order'! !

!WSCartViewPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:39'!
valid
	^true! !

WSWizardPage subclass: #WSConfirmOrderPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:40'!
enabled
	^model address notNil! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:37'!
renderAddress: anAddress on: html
	html
		definitionTerm: 'Address';
		definitionData: [
			html text: anAddress address1.
			anAddress address2 ifNotNil: [
				html break; text: anAddress address2.
			].
			html
				text: anAddress locality, ' ', anAddress state, ' ', anAddress postcode; break;
				text: anAddress country]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:40'!
renderContentOn: html
	html div id: 'confirm-order'; with: [
		html div: [self renderOrderSummaryOn: html].			
		html div: [self renderCustomerDetailsOn: html].			
		html div: [self renderShippingOn: html].
	]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:07'!
renderCustomerDetailsOn: html
	html heading level: 2; with: 'Customer Details'.
	html definitionList: [
		html 
			definitionTerm: 'Name';
			definitionData: model customer name;
			definitionTerm: 'Email';
			definitionData: model customer email.
	]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:39'!
renderOrderSummaryOn: html
	html heading level: 2; with: 'Order'.
	html paragraph: self session cart count printString, ' items, for a total of $', self session cart totalInDollars printString.
! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 21:38'!
renderShippingOn: html
	html heading level: 2; with: 'Shipping To:'.
	html definitionList: [
		html 
			definitionTerm: 'Name';
			definitionData: model address name.
		self renderAddress: model address on: html
	]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 13:19'!
title
	^'Confirm Purchase'! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:03'!
valid
	^true! !

WSWizardPage subclass: #WSCustomerPage
	instanceVariableNames: 'tempCustomer email2 fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:02'!
children
	^Array with:fields! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:31'!
email2
	^email2! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:32'!
email2: anEmail
	email2 := anEmail! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:26'!
enabled
	^true! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:01'!
initialize
	super initialize.
	tempCustomer := WSCustomer new.
	fields := WSForm new.
	self setupFields.! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:29'!
renderContentOn: html
	html div class: 'customer-details'; with: fields.	! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:59'!
save
	fields valid 
		ifTrue: [
			fields save.
			model customer: tempCustomer.
			^true]
		ifFalse: [^false]! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:01'!
setupFields
	| email1Field email2Field |
	fields add: (WSField text 
		label: 'Name';
		on: #name of: tempCustomer;
		beRequired).
	email1Field :=  (WSField text 
		label: 'Email';
		on: #email of: tempCustomer;
		beRequired).
	email2Field := (WSField text 
		label: 'Confirm Email';
		on: #email2 of: self;
		beRequired).
	fields add:email1Field.
	fields add: email2Field.
	fields addRule: [ :v | email1Field value = email2Field value] withDescription: 'Email addresses don''t match'.! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:31'!
title
	^'Customer Details'! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 20:59'!
valid
	^fields valid! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:38'!
enabled
	^false! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:39'!
initialize
	super initialize.! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 16:38'!
model: anObject
	model := anObject! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:58'!
onEnter! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 14:32'!
save
	"Attempt to save the data on the page, return success or failure"
	^true! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 12:54'!
title
	^self subclassResponsibility.! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 15:55'!
valid
	^false! !

WASystemConfiguration subclass: #WSConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:15'!
attributes
	^Array 
		with: (WAStringAttribute key: #paypalHost group: #paypal)
		with: (WAStringAttribute key: #accountEmail group: #paypal). ! !

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 21:16'!
paypalUrl
	^'www.sandbox.paypal.com'! !

WATask subclass: #WSCheckoutProcess
	instanceVariableNames: 'wizard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 2/24/2009 20:59'!
go
	[| order | 
	order := self call: wizard.
	order ifNil: [self answer].
	
	[(WSPlaceOrderCommand store: self store order: order) run ] 
		on: WSOrderError do: [:e | 
			self call: (WSOrderErrorPage error: e).
			wizard goToFirstPage].
	self call: (WSPayPalCheckout order: order).	
	self answer] repeat! !

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 22:00'!
initialize
	super initialize.
	wizard := WSCheckoutWizard new.! !

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 1/2/2009 17:50'!
store
	^self session store! !

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 21:00'!
wizard
	"for testing purposes"
	^wizard! !

!WSCheckoutProcess methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 21:00'!
wizard: aWizard
	"for testing purposes"
	wizard := aWizard! !

WATask subclass: #WSTestOrderWizard
	instanceVariableNames: 'order page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSTestOrderWizard methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:19'!
go
	self answer: order! !

!WSTestOrderWizard methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:58'!
goToFirstPage
	page := 1.! !

!WSTestOrderWizard methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 21:01'!
initialize
	super initialize.
	page := 2.! !

!WSTestOrderWizard methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:19'!
order: anOrder
	order := anOrder! !

!WSTestOrderWizard methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 20:58'!
page
	^page! !

WAImageTag subclass: #WSImageBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSImageBrush methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:58'!
image: anImage
	self resourceUrl: WSImageLibrary path, anImage! !

WAMagmaSession subclass: #WSSession
	instanceVariableNames: 'store announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

WSSession subclass: #TestSiteSession
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-TestSite'!

!TestSiteSession methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 21:48'!
cart
	^cart! !

!TestSiteSession methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 21:47'!
initialize
	super initialize.
	self resetCart! !

!TestSiteSession methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 21:48'!
resetCart
	cart := WSCart new! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:30'!
announce: anAnnouncement
	announcer announce: anAnnouncement! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:52'!
announcer
	^announcer! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:31'!
initialize
	super initialize.
	announcer := Announcer new.! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:52'!
on: anAnnouncement do: aBlock
	^announcer on: anAnnouncement do: aBlock.! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 22:03'!
store
	store ifNil: [store := self magmaSession root at: #store].
	^store! !

WSSession subclass: #WSTestSession
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Tests-UI'!

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 1/24/2009 21:49'!
cart
	^cart! !

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 18:13'!
cart: aCart
	cart := aCart! !

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 10:16'!
commit: aBlock
	aBlock value! !

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 10:18'!
initialize
	super initialize.
	self setUpStore.
	self resetCart! !

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 00:36'!
magmaSession
	^magmaSession ifNil: [magmaSession := WSTransactionalStub new]! !

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:56'!
magmaSession: aSession
	magmaSession := aSession! !

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 10:18'!
resetCart
	cart := WSCart new.! !

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 2/27/2009 20:51'!
setUpStore
	store := WSStore new.
	store addProduct: (WSProduct new
		name: 'Test product 1';
		description:  'Product description 1';
		price: 12345;
		enable;
		yourself).
	store addProduct: (WSProduct new
		name: 'Test product 2';
		description:  'Product description 2';
		price: 33000;
		enable;
		yourself).
	store addProduct: (WSProduct new
		name: 'Test product 3';
		description:  'Product description 3';
		price: 44000;
		disable;
		yourself).! !

!WSTestSession methodsFor: 'as yet unclassified' stamp: 'srh 1/4/2009 12:06'!
store: aStore
	store := aStore! !

Error subclass: #WSOrderError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!
WSImage initialize!
